{$V-,B-,I-,A-,E-,F-,N-,O-,R-,S-}
unit def;
interface
uses decoder,tpinline,tpmemo,tpwindow,tppick,tpstring,tpcrt;
type int=integer;
     bool=boolean;
     string80=string[100];
     string20=string[20];

const tr=true;
      fl=false;
      max_len_entry=20;
      max_win=100;
      ver='XVR Decoder V1.05 control file';
      ver_pick='XVR Decoder V1.05 pick file';
      promted:bool=tr;
      gen_lst:bool=fl;
      cvt_names:bool=fl;

type t_mm_type=(none,branch,loop,prog,data,sub,udef);
     ptr_mark_tree=^mark_tree;
     ptr_str=^string;
     ptr_att_link=^att_link;
     ptr_shift_tree=^shift_tree;
     ptr_shift_tab=^shift_tab;
     t_at=(a_word,a_mark,a_stringz,a_stringh,a_com,a_shift,a_byte,a_char);
     att_link=record
                link:ptr_att_link;
		a_type:t_at;
                count:byte;
                t_n:m_type;
	      end;

     shift_tab=record
                 name:string[8];
                 key:byte;
                 left,right:ptr_shift_tab;
               end;

     shift_tree=record
                 cnt:byte;
                 val:byte;
                 shifts:ptr_shift_tab;
                 left,right:ptr_shift_tree;
                end;

     mark_tree=record
                 mm_type:t_mm_type;
                 name:string[8];
                 adress,ent_count:word;
                 key:byte;
                 coment:ptr_str;
                 att_link:ptr_att_link;
                 left,right:ptr_mark_tree;
               end;
     iter_func=procedure (var a:mark_tree);
     mem_arr=array[0..maxint] of byte;
     t_cur_t=(d_fix,d_unfix,d_undef);
     ptr_entry_rec=^entry_rec;
     entry_rec=record
                len:byte;
                link:ptr_entry_rec;
                body:array[0..max_len_entry] of word;
               end;

var loc_io:word; loc_fil:file; loc_er:jumprecord;

var chek_memory,bounds,chek_fix:jumprecord;
    mem_file_name,ctrl_file_name:string80;
    bot_mem:pointer;
    memory,flags:^mem_arr;
    shift_adress:word;
    end_adress:word;
    cur_ent:word;
    ct,cur_ct:c_type;
    top_scr,cur_scr:word;
    scr_adr:array[0..23]of word;
    cur_t:t_cur_t;
    cur_st:t_at;
    abs_cur_pos:byte;
    mode_lst,mode_asm:bool;
    col_cur:byte;
    sh_stat:bool;
    atr_cur:string20;
    cur_sbt:m_type;
    make_change:bool;
    up_os:string;
    up_fs,up_ns:string20;
    head:word;
    win_rec:array[0..max_win] of record adr_at_top, adr_at_cur:word end;
    ctrl_modif,tr_break:bool;
    top_entry:ptr_entry_rec;
    top_mark_tree:ptr_mark_tree;
    top_shift_tree:ptr_shift_tree;
    me:emcontrolblock;
    sv_exitproc:pointer;
    con_err:int;
    win:windowptr;
    Inhelp:bool;

const iden:string[12]='Colors setup';
      col_pick_file:pickcolorarray=($1f,$1e,$1b,$4f,$1f,$4f);
      mcolor:array[1..15] of byte=
    ($2f,$17,$1f,$1b,$3f,$70,$4b,$4f,$7a,$74,$0c,$2b,$2c,$71,$1c);
var colors:record
            mark,undef,def,fix,sel_mark,status,err,err_mark,atr_type,
            sel_status,atr_mark,mem,frame,help,notst
           :byte
     end absolute mcolor;

const undef_as_db:bool=fl;

function find_shift(vval:byte;var f_add:bool):ptr_shift_tree;
function get_shift(val,key:byte):string;
function add_shift(val:byte; var name:string20):byte;
procedure write_out(var adr:word; lst,assm:bool; var fo);
function out_sp(adr:word):bool;
function mb(adr:word):byte;
function mw(adr:word):word;
function fb(adr:word):byte;
procedure sett(adr:word; t:t_flags);
procedure setf(adr:word; t:byte);
procedure adds(var s:string; s1:string);
function add_mark_auto(adr,curadr:word;m_t:m_type):string;
function find_mark(adr:word;var f_add:bool):ptr_mark_tree;
function m_name(p:ptr_mark_tree):string;
function len(var s:string):byte;
procedure unpck_all(var s:string);
function unpck(var s:string;len:byte):string;
function unpck_a(var s:string):string;
function pop_entry(var adr:word):bool;
function free_entry:bool;
procedure init_entry;
procedure push_entry(adr:word);
function one_str_cs(sd:string; var cs:byte; ln:word; atr:byte):word;
function choise_str(ch_s:string; init_ch:byte; var f:bool; col,selcol:byte):
                                                                      byte;
procedure help_mes(str:string);
procedure help;
procedure show_stat;
procedure mes(s:string; col:byte);
procedure c_off;

implementation


procedure c_off;
begin
 portw[$3d4]:=$ff0e;
 portw[$3d4]:=$ff0f;
end;

procedure show_stat;
var s:string;
begin
 if sh_stat then begin
  s:='ADRESS:'+hexw(cur_scr)+'        MODE:';
  if mode_lst then s:=s+'LST' else s:=s+'ASM';
  s:=s+'        UNDEFINE:';
  if mode_asm then s:=s+'ASM' else s:=s+'HEX';
  if promted then s:=s+'     P  ' else s:=s+'        ';
  if ctrl_modif then s:=s+'MODIFIED' else s:=s+charstr(' ',8);
  s:=s+'        Mem:'+long2str(maxavail div 1024)+'k';
  Fastwrite(pad(S,80),1,1,colors.status);
 end else sh_stat:=tr;
end;

procedure mes(s:string; col:byte);
begin
 fastwrite(center(s,80),1,1,col);
 sh_stat:=fl
end;

procedure help_mes(str:string);
begin
 fastwrite(center(str,80),25,1,colors.help);
 Inhelp:=fl;
end;

procedure help;
begin
 help_mes(
'F2-Save F3-Load F4-Add mark F5-Att mark F6-Trace F7-Info F8-Cur type F9-calc');
 Inhelp:=tr;
end;

function choise_str(ch_s:string; init_ch:byte; var f:bool; col,selcol:byte):
                                                                      byte;
var so,sc:string80; i,j,k,l:word;
begin
 choise_str:=init_ch;
 f:=fl;
 i:=WordCount(ch_S,['|']);
 j:=81-length(ch_s)+i;
 k:=j mod i shr 1;
 j:=j div i;
 so:=ExtractWord(1,ch_S,['|'])+charstr(' ',k+j);
 sc:='';
 for k:=2 to i do begin
  l:=length(so);
  sc:=sc+chr(l+1);
  so:=so+ExtractWord(k,ch_S,['|']);
  sc:=sc+chr(length(so)-l);
  if k<>i then so:=so+charstr(' ',j)
 end;
 fastwrite(pad(so,80),1,1,col);
 help_mes(^[^Z' - for move, '^[' - for select, <ESC> - for cansel');
 repeat
  i:=one_str_cs(sc,init_ch,1,selcol)
 until (i=$1c0d) or (i=$011b);
 sh_stat:=tr;
 show_stat;
 help;
 if i=$1c0d then choise_str:=init_ch else f:=tr
end;

function _readkeyword:word;
var pr,p:word;
begin
 if InHelp then begin
   pr:=$ff;
   repeat
    p:=KbdFlags and $f;
    if p<>pr then begin
      pr:=p;
      if (p and 8)<>0 then
        Help_mes('ALT: S - shift mark, L - loop mark, X - exit')
      else if (p and 4)<>0 then Help_mes('CTRL: F7 - Short info')
      else if (p and 3)<>0 then Help_mes('SHIFT: F7 - Switch promted mode')
      else help;
    end
   until CheckKbd(p);
   Inhelp:=tr;
 end;
 _readkeyword:=readkeyword
end;

function one_str_cs(sd:string; var cs:byte; ln:word; atr:byte):word;
var sv:string; f,t:byte; w:word; rb:int;
begin
 rb:=length(sd) shr 1 -1;
 c_off;
 if rb<0 then one_str_cs:=_readkeyword else begin
  if cs>rb then cs:=rb;
  repeat
   f:=ord(sd[cs shl 1+1]); t:=ord(sd[cs shl 1+2]);
   ReadAttribute(t,ln,f,sv);
   ChangeAttribute(t,ln,f,Atr);
   c_off;
   w:=_readkeyword; one_str_cs:=w;
   WriteAttribute(Sv,ln,f);
   case w of
    $4d00:if cs<rb then inc(cs) else cs:=0;
    $4b00:if cs>0 then dec(cs) else cs:=rb;
   else exit
   end
  until fl
 end
end;

procedure push_entry(adr:word);
var p:ptr_entry_rec;
 begin
  if out_sp(adr) then exit;
  setf(adr,c_entry);
  if (fb(adr) and c_prog)<>0 then begin
   if (fb(adr) and mask_type)<>byte(t_m1) then setf(adr,c_data);
   exit
  end;
  if (top_entry=nil) or (top_entry^.len=max_len_entry) then begin
   new(p);
   p^.link:=top_entry;
   top_entry:=p;
   p^.len:=0
  end;
  with top_entry^ do begin
   body[len]:=adr;
   inc(len)
  end
 end;

procedure init_entry;
var p,p1:ptr_entry_rec;
begin
 p:=top_entry;
 while p<>nil do begin
  p1:=p^.link;
  dispose(p);
  p:=p1
 end;
 top_entry:=nil;
 ctrl_modif:=tr
end;

function free_entry:bool;
var p:ptr_entry_rec;
begin
 free_entry:=tr;
 if top_entry=nil then exit;
 if top_entry^.len=0 then begin
  p:=top_entry;
  top_entry:=p^.link;
  dispose(p)
 end;
 free_entry:=top_entry=nil;
end;


function pop_entry(var adr:word):bool;
 begin
  pop_entry:=fl;
  if free_entry then exit;
  with top_entry^ do begin
   dec(len);
   adr:=body[len]
  end;
  pop_entry:=tr;
  ctrl_modif:=tr
 end;

procedure unpck_all(var s:string);
var j,i:word;
begin
 up_os:=''; up_fs:=''; up_ns:='';
 for i:=1 to length(s) do
  if s[i]=#0 then begin
   adds(up_fs,chr(length(up_os)+1));
   adds(up_ns,Copy(s,i+1,3));
   inc(i,4);
   j:=0;
   while s[i]<>#0 do begin
    adds(up_os,s[i]);
    inc(i);
    inc(j)
   end;
   adds(up_fs,chr(j))
  end else adds(up_os,s[i]);
end;

function unpck(var s:string;len:byte):string;
begin
 unpck_all(s);
 if length(up_os)>len then up_os[0]:=chr(len);
 unpck:=up_os;
end;

function unpck_a(var s:string):string;
begin
 unpck_all(s);
 unpck_a:=up_fs;
end;

function len(var s:string):byte;
var i,j:byte; f:bool;
begin
 i:=length(s);
 f:=tr;
 for j:=1 to length(s) do
  if s[j]=#0 then
   if f then begin dec(i,4); inc(j,3); f:=fl end
   else begin dec(i,1); f:=tr end;
 len:=i;
end;

function m_name(p:ptr_mark_tree):string;
const ms:array[t_mm_type] of char = ('?','B','L','P','D','S','U');
var i:int; rs:string; flag:bool;
begin
 with p^ do begin
  if (p=nil) or ((name='') and (mm_type=none)) then m_name:='' else
  if name<>'' then
   if not cvt_names then m_name:=name
   else begin
    rs[0]:=name[0];
    flag:=fl;
    for i:=1 to length(name) do
     if not (name[i] in ['0'..'9','a'..'z','A'..'Z','_']) then
      begin rs[i]:='_'; flag:=tr end
     else rs[i]:=name[i];
    if rs[1] in ['0'..'9'] then
     begin rs:='_'+rs; flag:=tr end;
    {find rs name in marks and add '_' if found}
    if flag then m_name:=rs+'_'+hexw(adress) else m_name:=rs;
   end
  else m_name:=ms[mm_type]+hexw(adress);
 end
end;

function find_mark(adr:word;var f_add:bool):ptr_mark_tree;
var p:ptr_mark_tree;l:^ptr_mark_tree;
 begin
  find_mark:=nil;
  l:=@top_mark_tree; p:=l^;
  while p<>nil do begin
   if p^.adress=adr then begin find_mark:=p; f_add:=fl; exit end;
   if p^.adress<adr then l:=addr(p^.right) else l:=addr(p^.left);
   p:=l^
  end;
  if not f_add then exit;
  new(l^);
  with l^^ do begin
   mm_type:=none;
   name:='';
   ent_count:=0;
   adress:=adr;
   left:=nil;
   right:=nil;
   coment:=nil;
   att_link:=nil;
   key:=0;
  end;
  find_mark:=l^;
  f_add:=tr;
 end;

function find_shift(vval:byte;var f_add:bool):ptr_shift_tree;
var p:ptr_shift_tree;l:^ptr_shift_tree;
 begin
  find_shift:=nil;
  l:=@top_shift_tree; p:=l^;
  while p<>nil do begin
   if p^.val=vval then begin find_shift:=p; f_add:=fl; exit end;
   if p^.val<vval then l:=addr(p^.right) else l:=addr(p^.left);
   p:=l^
  end;
  if not f_add then exit;
  new(l^);
  with l^^ do begin
   cnt:=1;
   val:=vval;
   left:=nil;
   shifts:=nil;
   right:=nil;
  end;
  find_shift:=l^;
  f_add:=tr;
 end;

function find_shift_tab(vval:byte;var f_add:bool; top:ptr_shift_tree):ptr_shift_tab;
var p:ptr_shift_tab;l:^ptr_shift_tab;
 begin
  find_shift_tab:=nil;
  l:=addr(top^.shifts); p:=l^;
  while p<>nil do begin
   if p^.key=vval then begin find_shift_tab:=p; f_add:=fl; exit end;
   if p^.key<vval then l:=addr(p^.right) else l:=addr(p^.left);
   p:=l^
  end;
  if not f_add then exit;
  new(l^);
  with l^^ do begin
   key:=vval;
   name:='';
   left:=nil;
   right:=nil;
  end;
  find_shift_tab:=l^;
  f_add:=tr;
 end;

function conv(inp:byte):byte;
type r=record l,h:byte end;
var i:word;
begin
 r(i).l:=$80;
 r(i).h:=inp;
 while (i and $8000) =0 do i:=i shl 1;
 conv:=r(i).h shl 1;
end;

function get_shift(val,key:byte):string;
var p:ptr_shift_tree;
    p1:ptr_shift_tab;
    f:bool;
begin
 f:=fl;
 get_shift:='';
 p:=find_shift(val,f);
 if p=nil then exit;
 p1:=find_shift_tab(key,f,p);
 if p1=nil then exit;
 get_shift:=p1^.name;
end;

var j:jumprecord;
    l_key:byte;

procedure iter(p:ptr_shift_tab);
begin
 if p=nil then exit;
 if p^.name='' then begin l_key:=p^.key; longjump(j) end;
 iter(p^.left);
 iter(p^.right);
end;

function f_key(p:ptr_shift_tree):byte;
var f:bool;
begin
 f:=tr;
 setjump(j);
 if f then begin
  f:=fl;
  iter(p^.shifts);
  f_key:=conv(p^.cnt);
  inc(p^.cnt);
  exit
 end;
 f_key:=l_key;
end;

function add_shift(val:byte; var name:string20):byte;
var p:ptr_shift_tree;
    f:bool;
    b:byte;
begin
 f:=tr;
 p:=find_shift(val,f);
 f:=tr;
 b:=f_key(p);
 find_shift_tab(b,f,p)^.name:=name;
 add_shift:=b;
end;

function add_mark_auto(adr,curadr:word;m_t:m_type):string;
var f:bool; p:ptr_mark_tree;
 begin
  f:=tr; p:=find_mark(adr,f);
  f:=m_t<>m_exist;
  with p^ do begin
   if f then begin inc(ent_count); ctrl_modif:=tr end;
   if name<>'' then begin add_mark_auto:=m_name(p); exit end;
   case m_t of
    m_sub:mm_type:=sub;
    m_datab,m_dataw:mm_type:=data;
    m_prog:case mm_type of
       none,data,udef:if adr>curadr then mm_type:=branch else mm_type:=loop;
            branch:if adr<=curadr then mm_type:=prog;
            loop:if adr>curadr then mm_type:=prog;
           end
   end;
   add_mark_auto:=m_name(p);
   if out_sp(adr) then exit;
   if f then setf(adr,c_entry);
   if f and (mm_type=data) and ( (fb(adr) and (c_data or c_prog))=0) then
   begin
    setf(adr,c_data);
    if m_t = m_datab then sett(adr,t_byte) else begin
     sett(adr,t_word); setf(adr+1,c_data); sett(adr+1,t_rest)
    end;
   end
  end
 end;

procedure adds(var s:string; s1:string);
begin
 move(s1[1],s[succ(length(s))],length(s1));
 inc(s[0],length(s1));
end;

function mb(adr:word):byte; begin mb:=memory^[adr-shift_adress] end;

function mw(adr:word):word; type p=^word;
begin mw:=p(addr(memory^[adr-shift_adress]))^ end;

function fb(adr:word):byte; begin fb:=flags^[adr-shift_adress] end;

procedure sett(adr:word; t:t_flags);
begin
 if ((fb(adr) and c_fix)<>0) and ((fb(adr) and mask_type)<>byte(t)) then
  longjump(chek_fix);
 ctrl_modif:=tr;
 flags^[adr-shift_adress]:=(fb(adr) and mask_ntype) or byte(t);
end;

procedure setf(adr:word; t:byte);
begin
 if ((fb(adr) and c_fix)<>0) and ((not(fb(adr) and mask_type) and t
     and not c_entry)<>0) then longjump(chek_fix);
 ctrl_modif:=tr;
 flags^[adr-shift_adress]:=fb(adr) or t;
end;

function out_sp(adr:word):bool;
begin out_sp:=(adr < shift_adress) or (adr > end_adress) end;

procedure write_out(var adr:word; lst,assm:bool; var fo);
var mas_out:array[0..5] of string absolute fo;
    s,s1:string; i,j:word; begadr,lastadr:word;
    loc:byte; lf:bool;
    f,f1,f2:bool;
    nam:string[16];
    p:ptr_mark_tree;

 function sa:string;
  var a:s_t_flags;
  begin a:=[t_byte,t_char,t_word,t_mark,t_shift]; sa:=#0'  '+char(a);
        sa[2]:=char(lo(adr)); sa[3]:=char(hi(adr))  end;

begin
 mas_out[0]:=''; s1:='';
 if out_sp(adr) then exit;
 begadr:=adr;

 if (fb(adr) and (c_data or mask_type))=(c_data or byte(t_rest)) then begin
   s:='DB '+hex(mb(adr))+'H'; inc(adr)
 end else

 if  ((fb(adr) and c_prog)<>0) and ((fb(adr) and mask_type)<>byte(t_m1))
  then begin s:='DB '+hex(mb(adr))+'H'; inc(adr);
    while  (adr<=end_adress) and ((fb(adr) and c_prog)<>0)
       and ((fb(adr) and mask_type)<>byte(t_m1)) do begin
        adds(s,','+hex(mb(adr))+'H'); inc(adr)
    end
  end else

 if (fb(adr) and c_prog)<>0 then begin
  s:=decod(memory^[adr-shift_adress],flags^[adr-shift_adress],adr,md_write,
           ct,add_mark_auto);
  if gen_lst and (ct.f_status=notst) then begin
   s:=';'+s; s1:='DB ';
   for i:=begadr to adr-1 do s1:=s1+hex(mb(i))+'H,';
   dec(s1[0])
  end else
  if ct.f_status=conflict then begin
   adr:=begadr;
   if decod(memory^[adr-shift_adress],flags^[adr-shift_adress],adr,md_simple,
           ct,add_mark_auto)='' then ;
   if ct.f_status=conflict then inc(adr)
  end;
 end else

 if ((fb(adr) and c_data)<>0) or undef_as_db then begin
  f:=fl; f1:=fl; f2:=fl;
  i:=fb(adr) and not c_entry; j:=i;
  case t_flags(i and mask_type) of
   t_word,t_mark: s:='DW '+sa;
   t_char:s:='DB '+sa
  else s:='DB '+sa
  end;
  repeat
   if ((j and (c_prog or c_entry)<>0) or
      ((i xor j) and (mask_type or c_fix) <>0)) then
    f:=tr else
    begin
     if f1 and (i and mask_type <> byte(t_char)) then adds(s,',');
     case t_flags(i and mask_type) of
      t_word:begin adds(s,hex(mw(adr))+'H'); inc(adr) end;
      t_mark:begin f2:=fl; adds(s,m_name(find_mark(mw(adr),f2)));
                   inc(adr) end;
      t_shift:begin f2:=fl;
         adds(s,m_name(find_mark(adr+shortint(mb(adr)),f2))+'-$') end;
      t_char:begin loc:=mb(adr); lf:=(loc > 31) and (loc < 128);
                   case (byte(f1) shl 1 or byte(lf)) shl 1 or byte(f2) of
                      0:adds(s,hex(loc)+'H');
                      2:adds(s,''''+char(loc));
                      4:adds(s,','+hex(loc)+'H');
                      5:adds(s,''','+hex(loc)+'H');
                      6:adds(s,','''+char(loc));
                      7:adds(s,char(loc))
                   end;
                   f2:=lf
             end
     else adds(s,hex(mb(adr))+'H')
     end;
     inc(adr);
     if out_sp(adr) then f:=tr else begin
       j:=fb(adr); f:=len(s)>30; f1:=tr
     end
   end
  until f;
  if ((i and mask_type)=byte(t_char)) and f2 then adds(s,'''');
  adds(s,#0);
 end else

 begin
  if assm then s:=decod(memory^[adr-shift_adress],flags^[adr-shift_adress],
                       adr,md_simple,ct,add_mark_auto)
  else begin
   s:='';
   i:=0;
   inc(adr);
   while (adr < end_adress) and (i<15) and
         ((fb(adr) and (c_prog or c_data or c_entry))=0) do
    begin inc(adr); inc (i) end;
  end
 end;

 lastadr:=adr-1;
 f2:=s='';
 f:=fl;
 p:=find_mark(begadr,f);
 if(p<>nil) and (p^.coment<>nil) then
  adds(s,charstr(' ',35-len(s))+';'+stringfromheap(p^.coment));
 mas_out[0]:=s;
 nam:=m_name(p);
 i:=1;
 if s1<>'' then begin
  mas_out[1]:=charstr(' ',10)+s1;
  inc(i)
 end;
 for j:=begadr+1 to lastadr do
  if (fb(j) and c_entry)<>0 then begin
   s:=m_name(find_mark(j,f));
   if s<>'' then begin
    if nam='' then nam:='M'+hexw(begadr);
    f:=fl;
    mas_out[i]:=pad(s,10)+'EQU '+nam+'+'+long2str(j-begadr);
    inc(i)
   end
  end;
 f:=(mas_out[0]='') and (nam='');
 mas_out[i]:='';
 if nam<>'' then mas_out[0]:=pad(nam+':',10)+mas_out[0]
 else mas_out[0]:=charstr(' ',10)+mas_out[0];
 if f2 then begin
  s:=hexw(begadr)+':';
  for j:=begadr to lastadr do
   adds(s,hexb(mb(j))+' ');
  s:=pad(s,58)+':';
  for j:=begadr to lastadr do
   if mb(j) and $7f >= $20 then adds(s,char(mb(j) and $7f)) else adds(s,'.');
  if f then mas_out[0]:=s else begin
   if lst then mas_out[0]:=charstr(' ',21)+mas_out[0];
   mas_out[1]:=s; mas_out[2]:=''
  end
 end else
 if lst then begin
  for j:=1 to i-1 do
   mas_out[j]:=pad('-----',21)+mas_out[j];
  if lastadr-begadr > 4 then j:=begadr+4 else j:=lastadr;
  s:=hexw(begadr)+':';
  for i:=begadr to j do
   adds(s,hexb(mb(i))+' ');
  mas_out[0]:=pad(s,26)+mas_out[0]
 end
end;

begin
 top_entry:=nil;
 top_mark_tree:=nil;
 top_shift_tree:=nil;
end.
