{$V-,B-,I-,A-,E-,F-,N-,O-,R-,S-}
unit def1;
interface
uses def,tpinline,decoder,tpcrt,tpstring,tpedit;

procedure _make_mark(adr:word; s:string20);
function mark_exist(var s:string20):bool;
procedure iterator(user_func:iter_func; forward_dir:bool);
procedure sort_marks(var p:ptr_mark_tree; count:word);
function chain(adr:word):bool;
procedure redr(adr:word;scr_st,scr_ed:int;f,dr_cur:bool);
procedure redraw;
procedure set_cur_scr;
function find_up(adr:word):word;
function s_str:string;
const loc_mn:array[t_at] of string[13]=
          ('Word         ','Mark         ','String zero  ','String hight ',
           'Command      ','Shift        ','Byte         ','Char         ');
      loc_mn1:array[m_datab..m_sub] of string[10]=
          ('DATA BYTE','DATA WORD','PROGRAM','SUBROUTINE');
      loc_mn2:array[t_cur_t] of string[5]=('Fix','UnFix','UnDef');
function get_adr(var adr:word; tt:string):bool;
function try_dig(var s:string; var i:word):bool;
procedure make_mark(adr:word);
procedure del_mark(adr:word);
function rs_win:bool;
function cmp(var s,s2:string):bool;
function g_a_f(var adr:word; chs:byte):bool;

implementation

function g_a_f(var adr:word; chs:byte):bool;
type b=record lo,hi:byte end;
var ad:word;
begin
 g_a_f:=tr;
 if (chs=0) or (chs*3>length(up_ns)) then exit;
 b(ad).lo:=ord(up_ns[chs*3-2]);
 b(ad).hi:=ord(up_ns[chs*3-1]);
 case t_flags(fb(ad) and mask_type) of
  t_shift:adr:=ad+1+shortint(mb(ad));
  t_mark,t_word:adr:=mw(ad)
 else exit
 end;
 g_a_f:=fl;
end;

function cmp(var s,s2:string):bool;
begin
 if length(s)>length(s2) then cmp:=fl else
 cmp:=compstruct(s[1],s2[1],length(s))=equal;
end;

function rs_win:bool;
var i:word;
begin
 rs_win:=fl;
 i:=head;
 if i=0 then i:=max_win else dec(i);
 with win_rec[i] do if adr_at_top=$ffff then
  mes('No preciding windows',colors.err)
 else begin
  head:=i;
  top_scr:=adr_at_top;
  cur_scr:=adr_at_cur;
  rs_win:=tr;
  redraw;
 end
end;

var loc_j:jumprecord; loc_a:word; loc_s:string20;
{$F+}
procedure loc_find(var p:mark_tree);
begin
 if stupcase(m_name(@p))<>loc_s then exit;
 loc_a:=p.adress;
 longjump(loc_j)
end;
{$F-}

procedure del_mark(adr:word);
var p:ptr_mark_tree; f:bool;
begin
 f:=fl;
 p:=find_mark(adr,f);
 if (p=nil) or (p^.name='') then exit;
 ctrl_modif:=tr;
 with p^ do begin
  name:='';
  dec(ent_count);
  if ent_count=0 then begin
   mm_type:=none;
   if not out_sp(adress) then
    flags^[adress-shift_adress]:=flags^[adress-shift_adress] and not c_entry;
  end;
 end;
 redraw
end;


function mark_exist(var s:string20):bool;
var f:bool;

 procedure fnd_shift(p:ptr_shift_tree);

  procedure fnd_tab(p:ptr_shift_tab);
  begin
   if p=nil then exit;
   if stupcase(p^.name)=loc_s then longjump(loc_j);
   fnd_tab(p^.left); fnd_tab(p^.right);
  end;

 begin
  if p=nil then exit;
  fnd_tab(p^.shifts);
  fnd_shift(p^.left); fnd_shift(p^.right);
 end;

begin
 f:=tr;
 loc_s:=stupcase(s);
 mark_exist:=tr;
 setjump(loc_j);
 if f then begin f:=fl;
   iterator(loc_find,tr);
   fnd_shift(top_shift_tree);
 mark_exist:=fl end;
end;


procedure make_mark(adr:word);
var p:ptr_mark_tree; f:bool; s:string20;
begin
 f:=tr;
 p:=find_mark(adr,f);
 s:=p^.name;
 if (s<>'') and not promted then exit;
 ReadString('Mark name>',1,1,69,colors.atr_type,colors.atr_type,$70,f,s);
 sh_stat:=tr; show_stat;
 if f or (s='') then exit;
 _make_mark(adr,s);
end;

procedure _make_mark(adr:word; s:string20);
const chs:byte=2;
var p:ptr_mark_tree; f:bool; i:byte;
begin
 f:=fl;
 p:=find_mark(adr,f);
 if mark_exist(s) then begin mes('Name already exist',colors.err); exit end;
 if m_name(p)='' then begin
  chs:=choise_str('Mark type:|DATA BYTE|DATA WORD|PROGRAM',chs,f,
                 colors.atr_type,colors.atr_mark);
  if f then exit;
  inc(p^.ent_count);
  p^.name:=s;
  f:=not out_sp(adr);
  if f then setf(adr,c_entry);
  case chs of
   0:begin p^.mm_type:=data; if f and (fb(adr)and(c_prog or c_data)=0) then
      begin setf(adr,c_data); sett(adr,t_byte) end;
     end;
   1:begin p^.mm_type:=data; if f and (fb(adr)and(c_prog or c_data)=0) then
      begin setf(adr,c_data); sett(adr,t_word);
            setf(adr+1,c_data); sett(adr+1,t_rest) end;
     end;
   2:begin p^.mm_type:=prog; push_entry(adr) end
  end
 end else
 if p^.name='' then inc(p^.ent_count);
 p^.name:=s;
 redraw;
 ctrl_modif:=tr;
end;

function try_dig(var s:string; var i:word):bool;
var f:bool; j:int;
begin
 f:=fl;
 if not(s[1] in ['0'..'9']) then begin
  loc_s:=stupcase(s);
  setjump(loc_j);
  if not f then begin f:=tr; iterator(loc_find,tr); f:=fl end;
  i:=loc_a;
 end;
 if not f then begin val('$'+s,i,j); f:=j=0 end;
 try_dig:=f
end;

function get_adr(var adr:word; tt:string):bool;
var s:string; i,j,k:word; f:bool;
begin
 get_adr:=tr;
 repeat
  if adr>0 then s:=hex(adr) else s:='';
  help_mes('Enter adress');
  ReadString(tt,1,1,79-length(tt),colors.atr_type,colors.atr_type,$70,f,s);
  help;
  if f then begin sh_stat:=tr; show_stat; exit end;
 until (s<>'') and try_dig(s,i);
 get_adr:=fl;
 adr:=i
end;

function s_str:string;
var s:string;
begin
 s:='';
 if (fb(cur_scr) and (c_prog or c_data))=0 then begin
   atr_cur:=#31#13#45#3#49#10;
   s:=loc_mn[cur_st];
   if cur_t=d_fix then s:=s+'Fix ' else s:=s+'    ';
   if cur_st in [a_mark,a_shift] then s:=s+loc_mn1[cur_sbt]
 end else begin
  atr_cur:=#32#5;
  s:=loc_mn2[cur_t]
 end;
 s_str:=pad(charstr(' ',31)+s,80);
end;


function find_up(adr:word):word;
var b:byte; i:word;
begin
 dec(adr);
 if adr<=shift_adress then find_up:=shift_adress else
 if fb(adr) and c_prog <>0 then
  while (adr>shift_adress) and ((fb(adr) and mask_type<> byte(t_m1)) or
         (fb(adr) and c_prog =0)) do
   if fb(adr) and c_prog=0 then begin find_up:=adr+1; exit end else dec(adr)
 else
 if fb(adr) and c_data <> 0 then begin
  b:=fb(adr) and mask_type;
  case t_flags(b) of
   t_word,t_mark,t_shift:i:=4;
   t_char:i:=16;
  else i:=8
  end;
  while (adr>shift_adress) and (i>0) and (fb(adr) and c_entry=0) do
   if(fb(adr) and mask_type=b) and (fb(adr) and (c_prog or c_data)=c_data)
    then begin dec(i); dec(adr) end
    else begin find_up:=adr+1; exit end
 end else begin
  if mode_asm then i:=2 else i:=15;
  while (adr>shift_adress) and (i>0) and (fb(adr) and c_entry=0) do
   if fb(adr) and (c_prog or c_data)<>0
    then begin find_up:=adr+1; exit end
    else begin dec(i); dec(adr) end
 end;
 find_up:=adr;
end;


procedure set_cur_scr;
var i:int; j:word;
begin
 j:=cur_scr;
 for i:=0 to 4 do j:=find_up(j);
 if out_sp(j) then top_scr:=cur_scr else top_scr:=j
end;

procedure redr(adr:word;scr_st,scr_ed:int;f,dr_cur:bool);
var fo:array[0..4] of string;
    sv_attr,attr,f_sv,p_cnt:byte;
    sv_adr,i,j:word;
    f1,f2:bool;

begin
 p_cnt:=0;
 repeat
  inc(p_cnt);
  if out_sp(cur_scr) then longjump(bounds);
  if (cur_scr<top_scr) or out_sp(top_scr) then begin
    set_cur_scr;
    if dr_cur then adr:=top_scr;
  end;
  f_sv:=fb(cur_scr);
  if not mode_asm and ((fb(cur_scr) and (c_prog or c_data))=0) then
   begin
     f2:=ctrl_modif;
     setf(cur_scr,c_entry);
     ctrl_modif:=f2
   end;
  sv_adr:=cur_scr;
  for i:=scr_st-2 to scr_ed-2 do begin
   if out_sp(adr) then begin
    FastWriteWindow(charstr(' ',80),i+2,1,colors.undef);
    scr_adr[i]:=$ffff
   end
   else begin
    if f and (cur_scr<=adr) then begin
     cur_scr:=adr; f:=fl;
     abs_cur_pos:=i
    end;
    scr_adr[i]:=adr;
    if make_change and (adr=cur_scr) then begin
     FastWriteWindow(S_str,i+2,1,colors.mark);
     scr_adr[i]:=$ffff;
     inc(i)
    end;
    j:=adr;
    f1:=adr=cur_scr;
    write_out(adr,mode_lst,mode_asm,fo);
    if (fb(j) and (c_prog or c_data))=0 then attr:=colors.undef else
    if (fb(j) and c_fix)<>0 then attr:=colors.fix else
    if notst=ct.f_status then attr:=colors.notst else
     attr:=colors.def;
    sv_attr:=attr;
    if attr=colors.notst then sv_attr:=colors.def;
    if f1 then col_cur:=attr;
    if not make_change and f1 and dr_cur then attr:=colors.mark;
    if f1 then cur_ct:=ct;
    j:=0;
    while (fo[j]<>'') and (i<=22) do begin
     fastwritewindow(pad(unpck(fo[j],80),80),i+2,1,attr);
     attr:=sv_attr;
     inc(j); inc(i);
     scr_adr[i]:=$ffff
    end;
    dec(i);
  end
  end;
  if out_sp(adr) then scr_adr[23]:=$ffff else scr_adr[23]:=adr;
  flags^[sv_adr-shift_adress]:=f_sv;
  if f then set_cur_scr else
  if abs_cur_pos>=20 then begin
   i:=abs_cur_pos-19; while scr_adr[i]=$ffff do inc(i);
   top_scr:=scr_adr[i];
   f:=tr
  end;
  adr:=top_scr;
 until not f or (p_cnt>1);
end;

procedure redraw;
begin redr(top_scr,2,24,tr,tr) end;

function chain(adr:word):bool;
var f:bool;
 function chek_chain:bool;
 var i:word;
 begin
  chek_chain:=tr;
  i:=head;
  if adr=cur_scr then exit;
  chek_chain:=fl;
  repeat
   if i=0 then i:=max_win else dec(i);
   if win_rec[i].adr_at_top=$ffff then exit;
  until win_rec[i].adr_at_cur=cur_scr;
  chek_chain:=tr;
 end;
begin
 chain:=fl;
 if out_sp(adr) then mes('Out of work space',colors.err) else
 if not chek_chain or (choise_str('Already in chain:|cansel|enter',1,f,
                                  colors.err,colors.err_mark)=1) and not f
 then begin
  with win_rec[head] do begin
   adr_at_top:=top_scr;
   adr_at_cur:=cur_scr
  end;
  if head = max_win then head:=0 else inc(head);
  win_rec[head].adr_at_top:=$ffff;
  chain:=tr;
  cur_scr:=adr;
  redraw
 end
end;

procedure sort_marks(var p:ptr_mark_tree; count:word);
var p1,p2:ptr_mark_tree; i,j:word;
begin
 if count=0 then p:=nil else begin
  i:=(count-1) div 2;
  p1:=p;
  for j:=1 to i do p:=p^.left;
  p2:=p^.left;
  sort_marks(p1,i);
  sort_marks(p2,count div 2);
  p^.left:=p1;
  p^.right:=p2;
 end
end;

procedure iterator(user_func:iter_func; forward_dir:bool);
 procedure it(pt:ptr_mark_tree);
  begin
   if pt=nil then exit;
   if forward_dir then it(pt^.left) else it(pt^.right);
   user_func(pt^);
   if forward_dir then it(pt^.right) else it(pt^.left);
  end;

 begin it(top_mark_tree) end;


end.