{$V-,B-,I-,A-,E-,F-,N-,O-,R-,S-}
unit infor;
interface
uses tpcrt,def,decoder,tpstring,tpinline,tpsort,def1,tppick,tpmemo,
     tpwindow,tpedit;
type wptr=^word;
     sb=set of bool;
     dm=array[0..$3ff0] of ptr_mark_tree;
     dm1=array[0..$7ff0] of word;
     srec=record mark,pl_adr:word end;
     rec=array[0..$3ff0] of srec;


type sc_code=(q_m1, q_com, q_byte, q_char, q_word, q_rest, q_mrk, q_shift,
              q_in, q_out, q_f1, q_update, q_entry, q_fix, q_data, q_prog,
              q_mark, q_comma, q_point, q_orsig, q_eof, q_minus );
     s_set=set of q_m1..q_prog;
     t_set=array[0..$1fff,bool] of s_set;
     t_st=(st_in, st_out, st_none);
     w_mas=array[0..$3fff] of word;

var b_str:string; c_lin, c_pos, max_cell, cell_cnt:int;
    st_adr:t_st; c_adr, beg_adr, end_adr:word; arr:pointer; arr_sz:word;
    f_t_buf:array[0..2047] of char;
    in_coma:bool;

var s_sp,s_nm:sb;
    s_tp:set of t_mm_type;
    loc_ar:^dm;
    loc_mrk:^rec absolute loc_ar;
    ar:^dm1;
    loc_p:^ptr_mark_tree;
    loc_st,loc_bnd:int;
var scr_loc_stat:byte;
const scr_x:byte=1;
      scr_y:byte=2;
      scr_r_buf:string80='';
      transp_scr:charset=[#8];
      transp_scr_c:set of byte =[];
      anch=['0'..'9','A'..'z','_'];

function readkeyw:word;

function get_sh:string;
function get_lp:string;
procedure f_mem(var a; disp,size:word);
procedure gen_xref;
procedure gen_sym(var f:text);
procedure info_marks(mrk_adr:word);
procedure info_window;
procedure info_entry;
procedure info_memory;
procedure info_prim(choise:byte);
function get_var_name(val:byte):byte;   { key }

implementation


function get_str_pr(adr:word; len:byte):string;
var fo:array[0..5] of string; i:word;
begin
 i:=adr;
 write_out(adr,fl,fl,fo);
 fo[1]:=up_os;
 fo[2]:=up_fs;
 fo[3]:=up_ns;
 fo[0]:=hexw(i)+':  '+unpck(fo[0],len-7);
 up_os:=fo[1];
 up_fs:=fo[2];
 up_ns:=fo[3];
 get_str_pr:=fo[0];
end;

function g_e_a(n:word):wptr;
var p:ptr_entry_rec;
begin
 g_e_a:=nil;
 p:=top_entry;
 while (n>max_len_entry) and (p<>nil) do
  begin dec(n,max_len_entry); p:=p^.link end;
 if n>max_len_entry then exit;
 g_e_a:=@p^.body[n]
end;

function get_ind(n:word):word;
begin
 if head<n then get_ind:=head-n+max_win+1 else get_ind:=head-n
end;

{$F+}
function get_str(n:word):string;
begin
 if loc_bnd=0 then get_str:=hexw(loc_ar^[n-1]^.adress)+'    '+
                            m_name(loc_ar^[n-1])
              else get_str:=pad(m_name(loc_ar^[n-1]),14)+
                            hexw(loc_ar^[n-1]^.adress);
end;

function get_str_1(n:word):string;
begin
 get_str_1:=get_str_pr(ar^[n-1],66)
end;

function get_str_2(n:word):string;
begin
 get_str_2:=get_str_pr(win_rec[get_ind(n)].adr_at_cur,66)
end;

function get_str_3(n:word):string;
begin
 get_str_3:=get_str_pr(g_e_a(n-1)^,66)
end;

procedure loc_c(var p:mark_tree);
begin
 with p do
  if ((name='') in s_nm)and(out_sp(adress) in s_sp)and(mm_type in s_tp) then
  begin
   loc_ar^[loc_st]:=@p; inc(loc_st);
   if loc_st>loc_bnd then longjump(chek_memory)
  end
end;

function loc_comp(var p1,p2:ptr_mark_tree):bool;
begin
 loc_comp:=m_name(p1) < m_name(p2)
end;

procedure put_el;
var i:int;
begin
 for i:=0 to loc_st-1 do if not putelement(loc_ar^[i]) then exit;
end;

procedure get_el;
var i:int;
begin
 for i:=0 to loc_st-1 do if not getelement(loc_ar^[i]) then exit;
end;

procedure put_en;
var w:word;
begin
 while pop_entry(w) and putelement(w) do;
end;

procedure get_en;
var w,l_w:word;
begin
 init_entry;
 loc_st:=0;
 l_w:=$ffff;
 while getelement(w) do
  if w<>l_w then begin inc(loc_st); push_entry(w); l_w:=w end;
end;

function en_comp(var a,b:word):bool; begin en_comp:= a < b end;

function en_comp1(var a,b:srec):bool;
begin
 en_comp1:= (a.mark < b.mark) or (a.mark=b.mark) and (a.pl_adr<b.pl_adr)
end;

procedure loc_si(var p:mark_tree);
var pt:ptr_mark_tree; p2,p1:ptr_att_link;
begin
 with p do
  if (name='') and (mm_type=none) and (coment=nil) and
     ((adress+2>end_adress) or (fb(adress) and c_prog = 0) or
      (fb(adress+2) and mask_type <> byte(t_rest)))
  then begin p1:=att_link;
    while p1<>nil do begin p2:=p1^.link; dispose(p1); p1:=p2 end;
    pt:=@p; dispose(pt);
  end else
   begin inc(loc_st); loc_p^:=ptr_mark_tree(@p); left:=nil; loc_p:=@left end
end;

var fil:^text;
var l_cnt:int;

procedure loc_sym(var p:mark_tree);
begin
 with p do
  if mm_type in [branch,loop,prog,data,sub] then begin
   write(fil^,hexw(adress),' ',StUpcase(m_name(@p)));
   inc(l_cnt);
   if l_cnt>=4 then begin l_cnt:=0; writeln(fil^); end
   else write(fil^,chr(9));
  end;
end;
{$F-}

procedure gen_sym(var f:text);
begin
 fil:=@f;
 l_cnt:=0;
 iterator(loc_sym,tr);
 writeln(f,^Z);
end;

function g_mem(var p):word;
var j:word; l:longint; p1:pointer absolute p;
begin
 l:=maxavail;
 if l>$fff0 then j:=$fff0 else j:=l;
 getmem(p1,j);
 g_mem:=j
end;

procedure f_mem(var a; disp,size:word);
var p1:pointer; p:pointer absolute a;
begin
 disp:=(disp+7) and $fff8;
 if disp<size then begin
  p1:=ptr(seg(p^)+(disp + ofs(p^)) shr 4,(disp + ofs(p^)) and 15);
  freemem(p1,size-disp)
 end
end;
var ss:sortstatus;

procedure gen_xref;
var i,j,l:word;
begin
 l:=g_mem(loc_mrk); loc_bnd:=l div 4;
 loc_st:=0;
 for i:=shift_adress to end_adress do begin
  if fb(i) and (c_prog or mask_type)=(c_prog or byte(t_m1)) then j:=i;
  if t_flags(fb(i) and mask_type) in [t_mark,t_shift] then
   with loc_mrk^[loc_st]  do begin
    if fb(i) and mask_type=byte(t_mark) then mark:=mw(i)
                                        else mark:=i+1+shortint(mb(i));
    if fb(i) and c_prog=0 then pl_adr:=i else pl_adr:=j;
    inc(loc_st);
    if loc_st>loc_bnd then begin f_mem(loc_mrk,0,l);longjump(chek_memory)end;
   end
 end;
 loc_mrk^[loc_st].mark:=$ffff;
 f_mem(loc_mrk,loc_st*4+4,l);
 if (loc_st>0) and (sort(loc_st,4,@put_el,@en_comp1,@get_el)<>sortsuccess)
  then begin f_mem(loc_mrk,0,loc_st*4+4); longjump(chek_memory) end;
 inc(loc_st);
end;

procedure info_marks(mrk_adr:word);
var f:bool; choi,i,j,k,l:word; p:ptr_mark_tree; s:string; b:byte;
const ms:array[0..5] of byte =(2,2,0,0,0,0);

 function chs:bool;
 const mn:array[0..2,0..5] of string[16]=(
 ('In  space','  Named  ','Sorted by adress','sub','prog','data'),
 ('Out space','Not named','Sorted by  names','   ','    ','    '),
 ('All space','All name ','','','',''));
 var i,j:word; s:string; f:bool;
 begin
  j:=6;
  chs:=tr;
  repeat
   s:='';
   for i:=0 to 5 do s:=s+'|'+mn[ms[i],i];
   i:=choise_str('Mark attribute:'+s+'|GO',j,f,colors.atr_type,
                       colors.atr_mark);
   j:=i;
   if f then exit;
   if i<6 then
    if (ms[i]=2) or (mn[ms[i]+1,i]='') then ms[i]:=0 else inc(ms[i]);
  until i=6;
  chs:=fl;
 end;

begin
 if mrk_adr=$ffff then begin
  if chs then exit;
  choi:=1;
  b:=succ(ms[0]);
  s_sp:=sb(b);
  b:=succ(ms[1]);
  s_nm:=sb(b);
  s_tp:=[];
  if ms[3]=0 then s_tp:=s_tp+[sub];
  if ms[4]=0 then s_tp:=s_tp+[prog,loop,branch];
  if ms[5]=0 then s_tp:=s_tp+[data];
  ctrl_modif:=tr;
  repeat
   p:=nil; loc_p:=@p; loc_st:=0;
   iterator(loc_si,tr);
   sort_marks(p,loc_st);
   top_mark_tree:=p;
   loc_st:=0;
   k:=g_mem(loc_ar); loc_bnd:=k div 4;
   iterator(loc_c,tr);
   f_mem(loc_ar,loc_st*4,k);
   if loc_st=0 then begin mes('No marks for info',colors.err); exit end;
   f:=fl;
   if ms[2]=1 then f:=sort(loc_st,4,@put_el,@loc_comp,@get_el)<>sortsuccess;
   if f then begin f_mem(loc_ar,0,loc_st*4); longjump(chek_memory) end;
   loc_bnd:=ms[2];
   pickmatrix:=3;
   help_mes(^X^Y^[^Z' -for move. '^[' -select. <F2>-Go to mark. <INS>-add mark. <DEL>-delete mark');
   f:=not pickwindow(@get_str,loc_st,7,2,72,24,tr,col_pick_file,'',choi);
   help;
   p:=loc_ar^[choi-1];
   f_mem(loc_ar,0,loc_st*4);
   if f then longjump(chek_memory);
   case pickcmdnum of
    pksexit:exit;
    pksuser2:if chain(p^.adress) then exit;
    pksuser0:begin j:=p^.adress;
                   if not get_adr(j,'Mark adress>') then make_mark(j)
             end;
    pksuser1:del_mark(p^.adress)
   end;
  until pickcmdnum=pksselect;
 end else begin
  f:=fl;
  p:=find_mark(mrk_adr,f);
  if m_name(p)='' then begin mes('Mark not found',colors.err); exit end
 end;
 j:=shift_adress;
 l:=g_mem(ar); loc_bnd:=l div 2;
 loc_st:=0; k:=0;
 for i:=shift_adress to end_adress do begin
  if fb(i) and (c_prog or mask_type)=(c_prog or byte(t_m1)) then j:=i;
  if (fb(i) and mask_type=byte(t_mark)) and (mw(i)=p^.adress) or
   (fb(i) and mask_type=byte(t_shift)) and (i+1+shortint(mb(i))=p^.adress)
  then begin
   if fb(i) and c_prog=0 then ar^[loc_st]:=i else ar^[loc_st]:=j;
   if (k=0) and (i>=cur_scr) then k:=loc_st;
   inc(loc_st);
   if loc_st>loc_bnd then begin f_mem(ar,0,l); longjump(chek_memory) end;
  end
 end;
 choi:=k+1;
 f_mem(ar,loc_st*2,l);
 s:='Mark '+m_name(p)+' at adress:'+hexw(p^.adress)+'. Type:';
 case p^.mm_type of
  branch:s:=s+'BRANCH';
  loop:s:=s+'LOOP';
  prog:s:=s+'PROGRAM';
  sub:s:=s+'SUBROUTINE';
  data:s:=s+'DATA';
 end;
 s:=s+'.  ';
 if p^.name='' then s:=s+'No name.' else
  begin s:=s+'Name:'+p^.name+'.';
   if loc_st=0 then s:=s+' No internal entry.';
  end;
 if p^.att_link<>nil then s:=s+' Have Att link.';
 mes(s,colors.atr_type);
 if loc_st=0 then exit;
 repeat
  pickmatrix:=1;
  help_mes(^X^Y^[^Z' -for move. '^[' -Go to .. , <ESC> - cansel');
  f:=not pickwindow(@get_str_1,loc_st,7,2,72,24,tr,col_pick_file,'',choi);
  help;
  if f then begin f_mem(ar,0,loc_st*2); longjump(chek_memory) end;
  if pickcmdnum=pksexit then begin f_mem(ar,0,loc_st*2); exit end;
 until pickcmdnum=pksselect;
 i:=ar^[choi-1];
 f_mem(ar,0,loc_st*2);
 if chain(i) then;
end;

{$F+}
function loc_compf(var p1,p2:ptr_shift_tab):bool;
begin
 loc_compf:=p1^.name<p2^.name;
end;

function get_strf(i:word):string;
begin
 if i>loc_st then get_strf:='<new name>'
             else get_strf:=ptr_shift_tab(loc_ar^[i-1])^.name;
end;
{$F-}

function get_var_name(val:byte):byte;   { key }
type m=array[byte] of ptr_shift_tab;
var f:bool; i,j,k,l,tot:word; p:ptr_shift_tree; p1:ptr_shift_tab; pp:^m;
    s:string;
const choi:word=1;

 procedure fill_ar(p:ptr_shift_tab);
 begin
  if (p=nil) or (tot>l) then exit;
  if p^.name<>'' then begin pp^[tot]:=p; inc(tot) end;
  fill_ar(p^.left); fill_ar(p^.right);
 end;

begin
 f:=tr;
 get_var_name:=0;
 p:=find_shift(val,f);
 tot:=0;
 k:=g_mem(pp); l:=k div 4;
 fill_ar(p^.shifts);
 if tot>l then mes('Out of memory!',colors.err);
 f_mem(pp,tot*4,k);
 loc_st:=tot; pointer(loc_ar):=pp;
 repeat
   if (tot<>0) and (sort(tot,4,@put_el,@loc_compf,@get_el)<>sortsuccess) then
    begin f_mem(pp,0,tot*4); longjump(chek_memory) end;
   pickmatrix:=3;
   help_mes(^X^Y^[^Z' -for move. '^[' -select. <INS>-edit var name.');
   f:=fl;
   if not promted and (tot<=1) then
    begin pickcmdnum:=pksselect; choi:=1 end
   else
    f:=not pickwindow(@get_strf,loc_st+1,7,2,72,24,tr,col_pick_file,'',choi);
   help;
   p1:=pp^[choi-1];
   if f then longjump(chek_memory);
   case pickcmdnum of
    pksexit:begin f_mem(pp,0,tot*4); help; exit end;
    pksuser0: begin
      s:=p1^.name;
      help_mes('Enter new name for variable');
      ReadString('Name>',1,1,74,colors.atr_type,colors.atr_type,$70,f,s);
      show_stat;
      if not f then
       if mark_exist(s) then mes('Name already exist',colors.err)
                        else p1^.name:=s;
     end;
    pksselect:
      if choi=loc_st+1 then begin
        s:='';
        help_mes('Enter new variable name');
        ReadString('Name>',1,1,74,colors.atr_type,colors.atr_type,$70,f,s);
        show_stat;
        if not f then
         if mark_exist(s) then mes('Name already exist',colors.err)
         else begin
           get_var_name:=add_shift(val, s);
           f_mem(pp,0,tot*4); help; exit
         end
        else
        if not promted then begin f_mem(pp,0,tot*4); help; exit end;
      end else begin
        get_var_name:=p1^.key;
        f_mem(pp,0,tot*4); help; exit
      end;
   end;
 until fl;
end;

function get_sh:string;
const cnt:word=1;
var s:string20;
begin
 repeat
  s:='sh'+long2str(cnt);
  if (cnt<>0) then inc(cnt);
 until not mark_exist(s) or (cnt=0);
 get_sh:=s;
end;

function get_lp:string;
const cnt:word=1;
var s:string20;
begin
 repeat
  s:='lp'+long2str(cnt);
  if (cnt<>0) then inc(cnt);
 until not mark_exist(s) or (cnt=0);
 get_lp:=s;
end;

procedure info_window;
var max_w,i:word;
begin
 i:=1;
 while win_rec[get_ind(i)].adr_at_top<>$ffff do inc(i);
 max_w:=pred(i);
 i:=1;
 if max_w=0 then begin mes('No window for info',colors.err); exit end;
 repeat
  pickmatrix:=1;
  help_mes(^X^Y^[^Z' -for move. '^[' -Go to window , <ESC> - cansel');
  if not pickwindow(@get_str_2,max_w,7,2,72,24,tr,col_pick_file,'',i) then
     longjump(chek_memory);
  help;
  if pickcmdnum=pksexit then exit;
 until pickcmdnum=pksselect;
 head:=get_ind(i-1);
 if rs_win then
end;

procedure info_entry;
var max_e,i,j:word; f:bool; p:ptr_entry_rec;
begin
 i:=1;
 repeat
  p:=top_entry;
  max_e:=0;
  while p<>nil do begin inc(max_e,p^.len); p:=p^.link end;
  if max_e=0 then begin mes('No entry for info',colors.err); exit end;
  if (sort(max_e,2,@put_en,@en_comp,@get_en)<>sortsuccess)
           then longjump(chek_memory);
  if loc_st=0 then begin mes('No entry for info',colors.err); exit end;
  ctrl_modif:=tr;
  pickmatrix:=1;
  help_mes(^X^Y^[^Z' -for move. '^[' -Go to entry, <INS>-add entry, <DEL>-delete entry');
  if not pickwindow(@get_str_3,loc_st,7,2,72,24,tr,col_pick_file,'',i)
           then longjump(chek_memory);
  help;
  case pickcmdnum of
   pksexit:exit;
   pksuser0:begin j:=0;
                  if not get_adr(j,'Entry adress>') then push_entry(j);
            end;
   pksuser1:if pop_entry(j) and (g_e_a(i-1)^<>j) then g_e_a(i-1)^:=j;
  end;
 until pickcmdnum=pksselect;
 if chain(g_e_a(i-1)^) then;
end;

procedure ch_b_type(adr:word);
var s:string; i:int; j,b,cb:byte; f:bool;
const mn:array[0..4] of string[6]=('Prog','Data','Fix','Entry','Update');
     mn1:array[0..7] of string[5]=('M1','Com','Byte','Char','Word','Rest',
                                   'Mark','Shift');
begin
 repeat
  cb:=fb(adr); j:=6;
  repeat
   s:=''; b:=cb;
   for i:=0 to 4 do begin
    if b and $80 = 0 then s:=s+'|'+charstr(' ',length(mn[i]))
                     else s:=s+'|'+mn[i];
    b:=b shl 1
   end;
   s:='Memory('+hexw(adr)+')atributes:'+s+'|'+
    center(mn1[cb and mask_type],5)+'|NEXT|PREVIOS';
   j:=choise_str(s,j,f,colors.atr_type,colors.atr_mark);
   if f then exit;
   if j=5 then cb:=(cb and mask_ntype) or (succ(cb) and mask_type) else
   if j<6 then cb:=cb xor 1 shl (7-j);
  until j>=6;
  if cb<>fb(adr) then begin
   if (cb xor fb(adr)) and mask_type<>0 then begin
    case t_flags(fb(adr) and mask_type) of
     t_mark:del_mark(mw(adr));
     t_shift:del_mark(adr+1+shortint(mb(adr)));
    end;
    case t_flags(cb and mask_type) of
     t_mark:make_mark(mw(adr));
     t_shift:make_mark(adr+1+shortint(mb(adr)));
    end;
   end;
   ctrl_modif:=tr;
   flags^[adr-shift_adress]:=cb;
  end;
  i:=adr;
  if t_flags(cb and mask_type) in [t_word,t_mark] then begin
   inc(adr); if fb(adr) and (c_prog or c_data)=0 then setf(adr,c_data);
   sett(adr,t_rest)
  end;
  if j=7 then adr:=pred(i) else inc(adr);
  if (fb(adr) and c_prog=0) or (fb(adr)and(c_prog or mask_type)=
    (c_prog or byte(t_m1))) then cur_scr:=adr;
  redraw;
 until fl;
end;


{$F+}
function readkeyw:word;
var kw:word; f,is_active:bool; s1:string[1];

 procedure curs(on:bool);
 begin
  if on then begin
   readattribute(1,scr_y,scr_x,s1);
   writeattribute(chr(ord(s1[1]) xor $77),scr_y,scr_x)
  end else
   writeattribute(s1,scr_y,scr_x)
 end;

 procedure up; begin if scr_y>1  then dec(scr_y) else scr_y:=24 end;
 procedure dn; begin if scr_y<25 then inc(scr_y) else scr_y:=2  end;
 procedure lt;
  begin if scr_x>1 then dec(scr_x) else begin scr_x:=80; up end end;
 procedure rt;
  begin if scr_x<80 then inc(scr_x) else begin scr_x:=1; dn end end;

 procedure w_rt;
 var s:string80; i:int;
 begin
  if scr_x=80 then rt;
  fastread(81-scr_x,scr_y,scr_x,s);
  for i:=1 to length(s)-1 do
   if not(s[i] in anch) and (s[i+1] in anch) then
    begin inc(scr_x,i); exit end;
  dn;
 end;

 procedure w_lt;
 var s:string80; i:int;
 begin
  if scr_x=1 then lt;
  fastread(scr_x,scr_y,1,s);
  dec(scr_x);
  for i:=length(s)-1 downto 2 do
   if (s[i] in anch) and not(s[i-1] in anch) then exit else dec(scr_x);
 end;

 function get_wrd:bool;
 label all;
 var s:string80; i,j:int;
 begin
  get_wrd:=fl;
  if scr_x=80 then rt;
  j:=scr_x;
  kw:=$ffff;
  fastread(81-scr_x,scr_y,scr_x,s);
  readkeyw:=ord(s[1]);
  i:=scr_y;
  if not (s[1] in anch) then w_rt;
  if scr_y<>i then begin scr_x:=1; exit end;
  for i:=scr_x-j+2 to length(s) do
   if not(s[i] in anch) then goto all;
  i:=length(s)+1;
  all: s[1]:=chr(i-2);
  scr_x:=j+i-2;
  rt;
  scr_r_buf:=string((@s[1])^);
  get_wrd:=tr;
 end;

begin
 if length(scr_r_buf)>0 then begin
  readkeyw:=ord(scr_r_buf[1]);
  scr_r_buf:=copy(scr_r_buf,2,length(scr_r_buf)-1);
  exit
 end;
 is_active:=fl;
 repeat
  repeat
   f:=kbdflags and $10 <> scr_loc_stat;
   if f<>is_active then begin
    is_active:=f;
    curs(f)
   end
  until checkkbd(kw);
  readkeyw:=readkeyword;
  if not is_active then exit;
  curs(fl);
  case kw of
   $4d00:rt;
   $4b00:lt;
   $4800:up;
   $5000:dn;
   $4700:scr_x:=1;
   $4f00:scr_x:=80;
   $4900:scr_y:=2;
   $5100:scr_y:=24;
   $1c0d:begin fastread(1,scr_y,scr_x,s1); readkeyw:=ord(s1[1]); rt; exit
         end;
   $1c0a:if get_wrd then exit;
   $7400:w_rt;
   $7300:w_lt;
  else if (lo(kw)=0)and(hi(kw)in transp_scr_c)or(chr(lo(kw))in transp_scr)
   then exit
  end;
  curs(tr)
 until fl;
end;
{$F-}


procedure err(s:string);
var i:int;
begin
 mes(s,colors.err);
 with me do begin
  curline:=c_lin;
  curcol:=c_pos;
  bufpos:=findlineindex(me,c_lin);
  i:=c_lin-5; if i<1 then i:=1;
  lineattop:=i;
  bufpostop:=findlineindex(me,i);
 end;
 f_mem(arr,0,arr_sz);
 longjump(loc_er)
end;

function scan:sc_code;
var s:string20; i:int; j:sc_code; f:bool;
const mn:array[q_m1..q_prog] of string[8] = ('M1','COMMAND','BYTE','CHAR',
        'WORD','REST','MARK','SHIFT','IN','OUT','','UPDATE','ENTRY','FIX',
        'DATA','PROGRAMM');
begin
 while b_str[c_pos]=' ' do inc(c_pos);
 f:=tr;
 case b_str[c_pos] of
  #0:scan:=q_eof;
  '-':begin scan:=q_minus; inc(c_pos) end;
  '|':begin scan:=q_orsig; inc(c_pos) end;
  ',':begin scan:=q_comma; in_coma:=tr; inc(c_pos) end;
  '.':if (c_pos<length(b_str)) and (b_str[c_pos+1]='.') then
       begin scan:=q_point; inc(c_pos,2) end else f:=fl;
  '0'..'9','A'..'z','_':begin
    i:=c_pos;
    while b_str[i] in anch do inc(i);
    s:=stupcase(copy(b_str,c_pos,i-c_pos));
    c_pos:=i; f:=fl;
    if not in_coma then
     for j:=q_m1 to q_prog do
      if cmp(s,mn[j]) then
       if f then err('Word too short') else begin f:=tr; scan:=j end;
    if not f and try_dig(s,c_adr) then begin f:=tr; scan:=q_mark end;
   end;
 else f:=fl
 end;
 if not f then err('Unknown identifier');
end;

procedure make_line(var inset);
var set0:array[bool] of s_set absolute inset;
    seta:t_set absolute inset;
    f:bool; op, term:sc_code; c_sgn:bool;

 procedure do0;
 var i:int;
 begin
  if not (op in [q_m1..q_shift,q_update..q_prog]) then
   err('Field identifer expected');
  set0[c_sgn]:=[op]+set0[c_sgn];
  if set0[fl]*set0[tr]<>[] then err('Conflict in filds');
  for i:=1 to cell_cnt do begin
   seta[i,not c_sgn]:=seta[i,not c_sgn]-[op];
   if seta[i,fl]+seta[i,tr]=[] then err('Groupe '+long2str(i)+
       ' is zero constant becose of this field');
  end;
 end;

 procedure doa;
 begin
  if not (op in [q_m1..q_shift,q_update..q_prog]) then
   err('Field identifer expected');
  seta[cell_cnt,c_sgn]:=[op]+seta[cell_cnt,c_sgn];
  if seta[cell_cnt,fl]*seta[cell_cnt,tr] <> [] then
     err('Groupe is high constant');
 end;

 procedure g_term;
 begin
  if term=q_minus then begin c_sgn:=fl; term:=scan end else c_sgn:=tr;
  op:=term; term:=scan
 end;

begin
 in_coma:=fl;
 cell_cnt:=0;
 term:=scan; f:=fl;
 set0[fl]:=[];
 set0[tr]:=[];
 repeat
  g_term;
  if term=q_orsig then begin
     inc(cell_cnt); dec(max_cell);
     if max_cell<0 then err('Insufficien memory');
     seta[cell_cnt,fl]:=[];
     seta[cell_cnt,tr]:=[];
     repeat
      doa;
      term:=scan;
      g_term;
     until term<>q_orsig;
     doa;
  end else do0;
  case term of
   q_comma:begin f:=tr; term:=scan end;
   q_in,q_out,q_mark,q_eof: f:=tr;
  end;
 until f;
 beg_adr:=shift_adress;
 end_adr:=end_adress;
 case term of
  q_minus:begin st_adr:=st_out; term:=scan end;
  q_in   :begin st_adr:=st_in ; exit end;
  q_out  :begin st_adr:=st_out; exit end;
  q_eof  :begin st_adr:=st_none;exit end;
 else st_adr:=st_in
 end;
 if term<>q_mark then err('Value expected');
 beg_adr:=c_adr; end_adr:=c_adr;
 if scan=q_point then
  if scan<>q_mark then err('Value expected') else end_adr:=c_adr;
 if scan<>q_eof then err('Extra symbols detected');
end;

procedure compil;
var  i:int; b1,base:word;
begin
 arr_sz:=g_mem(arr);
 max_cell:=arr_sz div 4 - 1;
 base:=max_cell;
 for c_lin:=1 to me.totallines do begin
  b1:=max_cell;
  getline(me,b_str,c_lin);
  if trim(b_str)<>'' then begin
   b_str:=b_str+#0;
   c_pos:=1;
   i:=base-max_cell;
   dec(max_cell,3);
   if max_cell<0 then err('Insufficient memory');
   make_line(t_set(arr^)[i+2]);
   w_mas(arr^)[i*2]:=(b1-max_cell)*2;
   w_mas(arr^)[i*2+1]:=byte(st_adr);
   w_mas(arr^)[i*2+2]:=beg_adr;
   w_mas(arr^)[i*2+3]:=end_adr;
  end
 end;
 i:=base-max_cell;
 w_mas(arr^)[i*2]:=0;
 f_mem(arr,i*4+2,arr_sz);
 arr_sz:=i*4+2;
end;

function comp(adr:word;var mas):bool;
var m:array[0..$3fff] of word absolute mas;
    p:int;

 function chek_set(var inmas; len:word; adr:word):bool;
 var ms:t_set absolute inmas; i:int; s:s_set;
 type s1=record l:set of 0..7; h:byte end;

 begin
  chek_set:=fl;
  s1(s).h:=fb(adr) and mask_ntype;
  s1(s).l:=[fb(adr) and mask_type];
  if (ms[0,tr]*s<>ms[0,tr]) or (ms[0,fl]-s<>ms[0,fl]) then exit;
  for i:=1 to len do
   if (ms[i,tr]*s=[]) and (ms[i,fl]-s=[]) then exit;
  chek_set:=tr
 end;

 function chek_adr(adr:word; tp:t_st; beg_a,end_a:word):bool;
 var c:word;
 begin
  chek_adr:=tr;
  if tp=st_none then exit;
  case t_flags(fb(adr) and mask_type) of
   t_word,t_mark:c:=mw(adr);
   t_shift:c:=adr+1+shortint(mb(adr));
  else c:=mb(adr)
  end;
  chek_adr:=(c>=beg_a) and (c<=end_a) = (tp=st_in)
 end;

begin { comp }
 p:=0;
 comp:=fl;
 while m[p]<>0 do begin
  if out_sp(adr) then exit;
  if not(chek_set(m[p+4], m[p] div 2 - 3, adr) and
         chek_adr(adr,t_st(lo(m[p+1])),m[p+2],m[p+3])) then exit;
  inc(adr);
  inc(p,m[p])
 end;
 comp:=tr
end;


procedure info_memory;
const ic:emtype=emnone;
var edo:emtype; f:bool; win:windowptr; j,j1,i:word;
begin
 initcontrolblock(me,6,3,74,23,colors.mem,$70,tr,fl,fl,8,0,20,maxint,
                  sizeof(f_t_buf),f_t_buf);
 if not (makewindow(win,5,2,75,24,tr,tr,fl,colors.mem,colors.frame,0,'')
    and displaywindow(win)) then longjump(chek_memory);
 setjump(loc_er);
 repeat
  help_mes('Enter mask for find. <F2> -accept it. <ESC> -cansel');
  edo:=editmemo(me,fl,ic);
  help;
  if (edo=emquit) and (not me.modified or
   (choise_str('Mask modified. Abandon changes?|YES|NO',1,f,colors.err,
               colors.err_mark)=0)) then
   begin disposewindow(erasetopwindow); show_stat;exit end;
 until edo=emuser0;
 compil;
 disposewindow(erasetopwindow);
 j:=cur_scr;
 j1:=top_scr;
 for i:=cur_scr to end_adress do
  if comp(i,arr^) then begin
   cur_scr:=i;
   while (cur_scr>shift_adress) and (fb(cur_scr) and c_prog<>0) and
         (fb(cur_scr) and mask_type<>byte(t_m1)) do dec(cur_scr);
   redraw;
   if choise_str('Target found at adress '+hexw(i)+'|EDIT|NEXT FIND',
                 1,f,colors.atr_type,colors.atr_mark)=0
      then ch_b_type(i) else
   if f then
    begin f_mem(arr,0,arr_sz);
          i:=cur_scr;
          cur_scr:=j; top_scr:=j1;
          if chain(i) then;
          redraw;
          exit
    end;
  end;
 f_mem(arr,0,arr_sz);
 cur_scr:=j; top_scr:=j1; redraw;
 mes('Target not found',colors.err)
end;

procedure info_prim(choise:byte);
const i:int=0;
var f:bool; j:word;
begin
 i:=choise_str('Info about|MARK|MEMORY',i,f,colors.atr_type,colors.atr_mark);
 if f then exit;
 if i=0 then begin
  if choise=0 then j:=cur_scr else if g_a_f(j,choise) then j:=0;
  if ((j<>0) and not promted) or not get_adr(j,'Mark adress for info>') then
   info_marks(j);
 end else begin
  j:=cur_scr;
  if promted and get_adr(j,'Memory adress for info>') then exit;
  ch_b_type(j);
 end
end;
end.
