{$V-,B-,I-,A-,E-,F-,N-,O-,R-,S-}
uses
     tpcrt,tpstring,tpinline,tpedit,tpmemo,tppick,tpdir,
     tpwindow,tpsort,dos,decoder,def,def1,infor,calcul;

{$ifdef demo}
procedure nodo;
begin mes('I can''t do it in DEMO version',colors.err) end;
const was_load:bool=fl;
{$endif}

procedure set_type(var entry:word; a_type:t_at; t_n:m_type);
var s:string;
begin
 setf(entry,c_data);
 case a_type of
  a_word:begin sett(entry,t_word); inc(entry);
               setf(entry,c_data); sett(entry,t_rest)
         end;
  a_mark:begin s:=add_mark_auto(mw(entry),entry,t_n);
               if t_n in [m_prog,m_sub] then push_entry(mw(entry));
               sett(entry,t_mark); inc(entry);
               setf(entry,c_data); sett(entry,t_rest)
         end;
 a_shift:begin s:=add_mark_auto(shortint(mb(entry))+entry,
                                entry,t_n);
               if t_n in [m_prog,m_sub] then
                  push_entry(shortint(mb(entry))+entry);
               sett(entry,t_shift)
         end;
  a_byte:sett(entry,t_byte);
  a_char:sett(entry,t_char);
  a_stringz:begin dec(entry);
             repeat
              inc(entry); setf(entry,c_data); sett(entry,t_char);
             until mb(entry)=0;
            end;
  a_stringh:begin dec(entry);
             repeat
              inc(entry); setf(entry,c_data); sett(entry,t_char);
             until mb(entry) > $7f;
            end;
 end;
 inc(entry)
end;

function trace(entry:word):int;
var s:string; i,j:word; ap:ptr_mark_tree; p:ptr_att_link;
     ct:c_type; f:bool;
begin
 trace:=1;
 if out_sp(entry) then exit;
 trace:=2;
 if (fb(entry) and (c_prog or mask_type))=(c_prog or byte(t_m1)) then exit;
 trace:=3;
 repeat
   i:=entry;
   s:=decod(memory^[entry-shift_adress],flags^[entry-shift_adress],entry,
            md_work,ct,add_mark_auto);
   ctrl_modif:=tr;
   case ct.f_status of
    conflict:begin for j:=i to entry do if fb(j) and c_fix =0 then
                    begin setf(j,c_data); sett(j,t_byte) end;
                   trace:=-1;
                   cur_ent:=entry+1;
                   exit
             end;
    overrun :begin setf(j,c_data);
                   trace:=-2;
                   cur_ent:=entry+1;
                   exit
             end
   end;
   if ct.f_entry then push_entry(ct.entry);
   if ct.f_status=term then exit;
   if ct.f_call then begin
    f:=fl;
    ap:=find_mark(ct.entry,f);
    if ap<>nil then begin
     p:=ap^.att_link;
     while p<>nil do with p^ do begin
      if a_type=a_com then begin trace:=-3; tr_break:=tr;
                                 cur_ent:=entry; exit
                           end;
      setf(entry,c_entry);
      for i:=1 to count do set_type(entry,a_type,t_n);
      p:=p^.link
     end    { while }
    end { if }
   end { if }
 until fl
end;

function auto_trace:int;
var st:jumprecord; i:word; j:int;
begin
 auto_trace:=0;
 st:=chek_fix;
 setjump(chek_fix);
 while pop_entry(i) do begin
  j:=trace(i);
  if j<0 then begin auto_trace:=j; chek_fix:=st; exit end
 end;
 chek_fix:=st
end;

procedure move_cur(n:word);
var i,j:word; s:string[1];
begin
 i:=cur_scr;
 cur_scr:=scr_adr[n];
 if make_change then begin redraw; exit end;
 j:=cur_scr;
 if (fb(j) and c_prog<>0) and (decod(memory^[cur_scr-shift_adress],
  flags^[cur_scr-shift_adress],j,md_write,cur_ct,add_mark_auto)='') then;
 ChangeAttribute(80,abs_cur_pos+2,1,col_cur);
 abs_cur_pos:=n;
 ReadAttribute(1,abs_cur_pos+2,1,s);
 col_cur:=byte(s[1]);
 ChangeAttribute(80,abs_cur_pos+2,1,colors.mark);
end;

procedure step_dn;
var i,j,k,l:word; f:bool;
begin
 i:=abs_cur_pos+1;
 if scr_adr[abs_cur_pos]=$ffff then inc(i);
 while (i<20) and (scr_adr[i]=$ffff) do inc(i);
 if i>=20 then begin
  i:=1; while scr_adr[i]=$ffff do inc(i);
  if i>23 then exit;
  j:=20;
  while (j<minword(19+i,23)) and (scr_adr[j]=$ffff) do inc(j);
  if scr_adr[j]<>$ffff then begin l:=j; cur_scr:=scr_adr[j] end
  else l:=abs_cur_pos;
  top_scr:=scr_adr[i];
  if (cur_scr<top_scr) or out_sp(top_scr) or make_change then redraw
  else begin
   k:=22;
   while scr_adr[k]=$ffff do begin dec(k) end;
   j:=scr_adr[k];
   ChangeAttribute(80,abs_cur_pos+2,1,col_cur);
   scrollwindowup(1,2,80,24,i);
   move(scr_adr[i],scr_adr[0],(23-i)*2);
   dec(abs_cur_pos,i);
   redr(j,2+k-i,24,fl,fl);
   move_cur(l-i);
  end;
 end else move_cur(i)
end;

procedure step_up;
var adr,i,i1:int; fo:array[0..4] of string; a1:byte;
begin
 i:=abs_cur_pos-1;
 while (i>=0) and (scr_adr[i]=$ffff) do dec(i);
 if i<0 then begin
  top_scr:=find_up(top_scr);
  cur_scr:=top_scr;
  i:=cur_scr;
  write_out(word(i),mode_lst,mode_asm,fo);
  if make_change or (word(i)<>scr_adr[0]) then redraw
  else begin
   ChangeAttribute(80,abs_cur_pos+2,1,col_cur);
   if (fb(cur_scr) and (c_prog or c_data))=0 then col_cur:=colors.undef else
   if (fb(cur_scr) and c_fix)<>0 then col_cur:=colors.fix else
   if ct.f_status=notst then col_cur:=colors.notst else
    col_cur:=colors.def;
   a1:=colors.mark;
   i:=0; while fo[i]<>'' do inc(i);
   scrollwindowdown(1,2,80,24,i);
   for i1:=0 to i-1 do begin
     fastwritewindow(pad(unpck(fo[i1],80),80),i1+2,1,a1);
     a1:=col_cur;
   end;
   i1:=23-i; while scr_adr[i1]=$ffff do inc(i1);
   i1:=scr_adr[i1];
   move(scr_adr[0],scr_adr[i],(23-i)*2);
   scr_adr[23]:=i1;
   scr_adr[0]:=cur_scr;
   fillchar(scr_adr[1],(i-1)*2,#$ff);
  end
 end else move_cur(i)
end;

procedure set_mode;
var i:byte;
begin
 i:=0;
 repeat
  show_stat;
  help_mes(^[^Z' - for move, '^[' - for select, <ESC> - for cansel');
  case one_str_cs(#8#4#25#3#45#3,i,1,colors.sel_status) of
   $1c0d,$5200:begin case i of
                      0:if get_adr(cur_scr,'New adress>') then;
                      1:mode_lst:=not mode_lst;
                      2:mode_asm:=not mode_asm;
                     end;
                     redraw
               end;
   $0f09,$011b:exit;
  end
 until fl
end;

procedure make_cur(choise:byte);
var f:bool;
begin
 if not make_change then exit;

 if (choise=1) or (fb(cur_scr) and (c_prog or c_data)<>0) then
  cur_t:=t_cur_t(choise_str('Cursor change fild:|FIX|UNFIX|UNDEF',
                 byte(cur_t),f,colors.atr_type,colors.atr_mark)) else
 if choise=2 then cur_sbt:=m_type(
    choise_str('Type of entry:|DATA BYTE|DATA WORD|PROGRAM|SUBROUTINE',
               byte(cur_sbt),f,colors.atr_type,colors.atr_mark)) else
  cur_st:=t_at(choise_str(
   'Cursor type:|WORD|MARK|STRING ZERO|STRING HIGHT|COMMAND|SHIFT|BYTE|CHAR',
               byte(cur_st),f,colors.atr_type,colors.atr_mark));
 redraw
end;


procedure step_prog(fil:byte; key:word);
var adr:word; tp:(ch,en,tm);
begin
 if key=$1c0a then begin
  if g_a_f(adr,fil) then adr:=0;
  if ((adr=0) or promted) and get_adr(adr,'Chain adress>') then exit;
  tp:=en
 end else begin
 if fb(cur_scr) and c_prog=0 then begin step_dn; exit end;
  if cur_ct.f_entry then begin
   adr:=cur_ct.entry;
   if cur_ct.f_status=term then tp:=ch else tp:=en
  end else
  if cur_ct.f_status=term then tp:=tm else begin step_dn; exit end;
 end;
 case tp of
  ch:begin cur_scr:=adr; redraw end;
  en:if not chain(adr) then step_dn;
  tm:if rs_win or tr then step_dn;
 end;
end;

procedure change_fl;
var i,j,k:word; ct:c_type; m,t:byte; s:string; f:bool; p:ptr_mark_tree;
    ap:ptr_att_link;
begin
 ctrl_modif:=tr;
 i:=cur_scr;
 if fb(cur_scr) and (c_prog or c_data)<>0 then begin
  i:=abs_cur_pos+2;
  while scr_adr[i]=$ffff do inc(i);
  i:=scr_adr[i]; m:=$ff; t:=0;
  case cur_t of
   d_fix: t:=c_fix;
   d_unfix: m:=lo(not c_fix);
   d_undef: m:=c_entry;
  end;
  for j:=cur_scr to i-1 do begin
   if (cur_t=d_undef) and (t_flags(fb(j) and mask_type) in [t_mark,t_shift])
   then begin
    if fb(j) and mask_type = byte(t_shift) then k:=j+1+shortint(mb(j))
                                           else k:=mw(j);
    f:=fl;
    p:=find_mark(k,f);
    if (p<>nil) and (p^.ent_count>0) then with p^ do begin
     dec(ent_count);
     if ent_count=0 then begin
      mm_type:=none;
      if not out_sp(k) then
        flags^[k-shift_adress]:=flags^[k-shift_adress] and not c_entry;
     end
    end
   end;
   flags^[j-shift_adress]:=(flags^[j-shift_adress] and m) or t;
  end
 end else
 begin
  if cur_st=a_com then begin
   s:=decod(memory^[cur_scr-shift_adress],flags^[cur_scr-shift_adress],i,
            md_work,ct,add_mark_auto);
   if ct.f_status in [conflict,overrun] then begin
    if ct.f_status=overrun then mes('Overrun',colors.err)
                           else mes('Conflict',colors.err);
    for j:=cur_scr to i do sett(j,t_byte);
    inc(i);
   end else begin
    if ct.f_entry then push_entry(ct.entry);
    if ct.f_call then begin
     f:=fl; p:=find_mark(ct.entry,f);
     ap:=p^.att_link;
     if (p<>nil) and (ap<>nil) and
      (choise_str('Command have Attr link|PROCEED|CANSEL',1,f,
                   colors.atr_type,colors.atr_mark)=0) then
      while (ap<>nil) and (ap^.a_type<>a_com) do with ap^ do begin
       setf(i,c_entry);
       for j:=1 to count do set_type(i,a_type,t_n);
       ap:=link
      end
     end
    end
  end else
   set_type(i,cur_st,cur_sbt);
  if cur_t=d_fix then for j:=cur_scr to i-1 do setf(j,c_fix)
 end;
 cur_scr:=i;
 redraw;
end;

procedure get_mark(choise:byte);
var adr:word;
begin
 if g_a_f(adr,choise) then adr:=0;
 if ((adr=0) or promted) and get_adr(adr,'Mark adress>') then exit;
 make_mark(adr);
end;

procedure make_comment;
var s:string; p:ptr_mark_tree; f:bool;
begin
 f:=tr;
 p:=find_mark(cur_scr,f);
 if p^.coment <> nil then s:=stringfromheap(p^.coment) else s:='';
 help_mes('Enter comment for this string');
 ReadString('Comment>',1,1,71,colors.atr_type,colors.atr_type,$70,f,s);
 sh_stat:=tr; show_stat; help;
 if f  then exit;
 disposestring(p^.coment);
 ctrl_modif:=tr;
 if s='' then begin
  p^.coment:=nil;
  if m_name(p)='' then
    flags^[cur_scr-shift_adress]:=fb(cur_scr) and not c_entry;
  redraw;
  exit
 end;
 p^.coment:=stringtoheap(s);
 setf(cur_scr,c_entry);
 redraw;
end;

function set_var(adr:word):bool;
var p:ptr_mark_tree; f:bool; i:byte;
begin
 f:=tr;
 set_var:=tr;
 p:=find_mark(cur_scr,f);
 i:=get_var_name(mb(adr));   { key }
 if i=0 then begin redraw; exit end;
 set_var:=fl;
 p^.key:=i;
 redraw;
end;

procedure make_fild(choise:byte);
type b=record lo,hi:byte end;
var adr:word; f:bool; et:s_t_flags; i,j:int; c_t,n_t:t_flags; s1,s:string;
const mn:array[t_byte..t_shift] of string[5]=('BYTE','CHAR','WORD','VAR',
          'MARK','SHIFT');
begin
 if choise=0 then make_mark(cur_scr) else
 if choise*3>length(up_ns) then make_comment else begin
  i:=choise*3-2;
  b(adr).lo:=ord(up_ns[i]);
  b(adr).hi:=ord(up_ns[i+1]);
  et:=s_t_flags(up_ns[i+2]);
  if out_sp(adr) then begin mes('Out of work space',colors.err); exit end;
  c_t:=t_flags(fb(adr) and mask_type);
  s:=''; s1:='';
  for n_t:=t_byte to t_shift do
   if n_t in et then begin s:=s+'|'+mn[n_t]; s1:=s1+char(n_t) end;
  i:=pos(char(c_t),s1); if i>0 then dec(i);
  n_t:=t_flags(s1[1+choise_str('New format fild:'+s,i,f,colors.atr_type,
                                colors.atr_mark)]);
  if f then exit;
  if (n_t=t_rest) and set_var(adr) then exit;
  if (n_t=c_t) and not(c_t in [t_shift,t_mark]) then exit;
  case c_t of
   t_mark:del_mark(mw(adr));
   t_shift:del_mark(adr+1+shortint(mb(adr)));
  end;
  case n_t of
   t_mark:make_mark(mw(adr));
   t_shift:make_mark(adr+1+shortint(mb(adr)));
  end;
  ctrl_modif:=tr;
  flags^[adr-shift_adress]:=(flags^[adr-shift_adress] and mask_ntype)
                                                       or byte(n_t);
  if n_t in [t_word,t_mark] then
   flags^[adr-shift_adress+1]:=(fb(adr+1) and mask_ntype) or byte(t_rest);
  redraw;
 end
end;

{$F+}
procedure loc_i(var p:mark_tree);
begin
 with p do
  if name<>'' then begin
   if mm_type in [prog,sub,branch,loop] then push_entry(adress);
  end else mm_type:=none
end;
{$F-}

procedure aut_tr;
var i,j:int; incl,f:bool; s:string; st,sc:word;
begin
 st:=top_scr; sc:=cur_scr; incl:=fl;
 if (choise_str('Include current adress|NO|YES',byte(tr_break),f,
   colors.atr_type,colors.atr_mark)=1) and not f then incl:=tr;
 if f then exit;
 if free_entry then
   i:=choise_str('Trace:|NEW',0,f,
                 colors.atr_type,colors.atr_mark)
 else
   i:=choise_str('Trace:|NEW|CONTINUE',1,f,
                 colors.atr_type,colors.atr_mark);
 if f then exit;
 ctrl_modif:=tr;
 if i=0 then begin
  init_entry;
  for i:=shift_adress to end_adress do
   if fb(i) and c_fix = 0 then flags^[i-shift_adress]:=0;
  if incl then begin push_entry(cur_scr); tr_break:=fl end;
  iterator(loc_i,tr);
  if free_entry then begin mes('No entry for trace',colors.err); exit end;
 end else
 if incl then begin push_entry(cur_scr); tr_break:=fl end;
 repeat
  fastwrite(center('Trace',80),1,1,colors.atr_type);
  i:=auto_trace;
  if i<0 then begin
   case i of
    -1:s:='Conflict in trace';
    -2:s:='Overrun in trace';
    -3:begin mes('Trace stoped',colors.err); cur_scr:=cur_ent;
             redraw; exit
       end;
   end;
   cur_scr:=cur_ent; redraw;
   j:=choise_str(s+':|CONTINUE|CANSEL',0,f,colors.err,colors.err_mark);
   if (j=1) or f then i:=0;
  end
 until i=0;
 top_scr:=st; cur_scr:=sc;
 show_stat;
 redraw;
end;

procedure to_up;
begin
 cur_scr:=shift_adress;
 top_scr:=shift_adress;
 redraw
end;

procedure to_dn;
var i,j:word;
begin
 j:=end_adress;
 cur_scr:=find_up(j);
 for i:=0 to 19 do j:=find_up(j);
 top_scr:=j;
 redraw
end;

{$F+}
procedure mem_st;
begin
 if sh_stat then memostatus(me)
end;

function get_mk:word;
begin
 get_mk:=readkeyw;
 sh_stat:=tr;
end;
{$F-}

procedure att_fil(fil:byte);
var ic:array[0..5] of emtype;
    adr:word; p:ptr_mark_tree; f:bool;  edo:emtype;
    dbuf:array[0..2000]of char;

 procedure fil_dbuf;
 var l:ptr_att_link; s:string; i:int;
 begin
  i:=0;
  l:=p^.att_link;
  while l<>nil do with l^ do begin
   if a_type=a_com then s:='Stop' else
   if a_type in [a_mark,a_shift] then s:=trim(loc_mn[a_type])+' '+trim(loc_mn1[t_n])+' ' else
    s:=trim(loc_mn[a_type])+' ';
   if count>1 then s:=s+'  '+long2str(count);
   s:=s+#$0d#$0a;
   l:=l^.link;
   move(s[1],dbuf[i],length(s));
   inc(i,length(s))
  end;
  dbuf[i]:=^Z;
 end;

 function conv(var is,os:string):int;
 var s:string; i,j:int; f:bool;
 const mn:array[1..12] of string[10] = ('WORD','BYTE','CHAR','MARK','STRING',
       'STOP','SHIFT','PROGRAMM','SUBROUTINE','DATA','HIGHT','ZERO');
 begin
  os:=''; conv:=0;
  for i:=1 to wordcount(is,[' ']) do begin
   f:=fl;
   s:=stupcase(extractword(i,is,[' ']));
   if s[1] in ['0'..'9'] then begin
    if not str2int(s,j) or (j<0) then begin conv:=-1; exit end;
    conv:=j; os:=os+'0'
   end else begin
    for j:=1 to 12 do
     if cmp(s,mn[j]) then
      if f then begin conv:=-2; exit end
           else begin f:=tr; os:=os+char(j+ord('0')) end;
    if not f then begin conv:=-1; exit end
   end
  end
 end;

 function compil:bool;
 label err;
 var i,j:int; cp,pnt:ptr_att_link; pt:^ptr_att_link; s,s1:string;
 begin
  compil:=fl;
  pnt:=nil;
  pt:=@pnt;
  for i:=1 to me.totallines do begin
   getline(me,s,i); s:=trim(s);
   if s<>'' then begin
    new(pt^); cp:=pt^; pt:=@cp^.link;
    with cp^ do begin
     link:=nil;
     count:=1;
     t_n:=mm;
     j:=conv(s,s1);
     case j of
      -1:begin mes('Unknown word',colors.err); goto err end;
      -2:begin mes('Word too short',colors.err); dec(s1[0]); goto err end;
     end;
     if s1[length(s1)]='0' then begin count:=j; dec(s1[0]) end;
     if s1= '1'  then a_type:=a_word else
     if s1= '2'  then a_type:=a_byte else
     if s1= '3'  then a_type:=a_char else
     if s1= '5;' then a_type:=a_stringh else
     if s1= '5<' then a_type:=a_stringz else
     if s1= '6'  then a_type:=a_com else
     if s1= '4:1'then begin a_type:=a_mark; t_n:=m_dataw end else
     if s1= '4:2'then begin a_type:=a_mark; t_n:=m_datab end else
     if s1= '48' then begin a_type:=a_mark; t_n:=m_prog end else
     if s1= '49' then begin a_type:=a_mark; t_n:=m_sub end else
     if s1= '7:1'then begin a_type:=a_shift; t_n:=m_dataw end else
     if s1= '7:2'then begin a_type:=a_shift; t_n:=m_datab end else
     if s1= '78' then begin a_type:=a_shift; t_n:=m_prog end else
     if s1= '79' then begin a_type:=a_shift; t_n:=m_sub end else
     begin mes('Unknown command',colors.err); s1:=''; goto err end
    end
   end
  end;
  cp:=pnt;
  pnt:=p^.att_link;
  p^.att_link:=cp;
  compil:=tr;
  err: while pnt<>nil do begin
   cp:=pnt^.link;
   dispose(pnt);
   pnt:=cp
  end;
  fillchar(ic,length(s1),chr(emwordright));
  ic[length(s1)+1]:=emnone;
  with me do begin
   curline:=i;
   curcol:=1;
   bufpos:=findlineindex(me,i);
   dec(i,5); if i<1 then i:=1;
   lineattop:=i;
   bufpostop:=findlineindex(me,i);
  end
 end;

var win:windowptr;

 begin { att_fil }
  if fil=0 then adr:=cur_scr else
  if g_a_f(adr,fil) then adr:=0;
  if ((adr=0) or promted) and get_adr(adr,'Subroutine adress>') then exit;
  f:=fl;
  p:=find_mark(adr,f);
  if p=nil then mes('No mark',colors.err) else
  if not(p^.mm_type in [branch,loop,prog,sub]) then
     mes('Mark not executable',colors.err) else
   begin
    dbuf[0]:=^Z;
    if p^.att_link<>nil then fil_dbuf;
    initcontrolblock(me,30,3,50,23,colors.mem,$70,tr,fl,fl,8,0,20,maxint,
                     sizeof(dbuf),dbuf);
    if not (makewindow(win,29,2,51,24,tr,tr,fl,colors.mem,colors.frame,0,'')
       and displaywindow(win)) then longjump(chek_memory);
    ic[0]:=emnone;
    repeat
     help_mes('Enter Att Link. <ESC> - cansel, <F2> - accept it');
     edo:=editmemo(me,fl,ic);
     help;
     if (edo=emquit) and (not me.modified or
      (choise_str('Filds modified. Abandon changes?|YES|NO',1,f,colors.err,
                  colors.err_mark)=0)) then
      begin disposewindow(erasetopwindow); show_stat;exit end;
    until (edo=emuser0) and compil;
    ctrl_modif:=tr;
    disposewindow(erasetopwindow);
    show_stat;
   end
 end;

procedure del_com(adr:word);
var p:ptr_mark_tree; f:bool;
begin
 f:=fl;
 p:=find_mark(adr,f);
 if (p=nil) or (p^.coment=nil) then exit;
 disposestring(p^.coment);
 p^.coment:=nil;
 ctrl_modif:=tr;
 redraw
end;

procedure init_mem;
var p:pointer;
begin
 p:=bot_mem;
 if p<>nil then release(p);
 mode_lst:=fl;
 mode_asm:=fl;
 make_change:=fl;
 sh_stat:=tr;
 head:=0;
 win_rec[max_win].adr_at_top:=$ffff;
 top_entry:=nil;
 top_mark_tree:=nil;
 cur_ent:=$ffff;
 cur_t:=d_fix;
 cur_st:=a_byte;
 cur_sbt:=m_prog;
 tr_break:=fl;
 cur_scr:=shift_adress;
 top_scr:=shift_adress;
end;

function _read_mem(var nm:string; size:word):int;
var fil:file; w,io:word;
begin
{$ifdef demo}
 was_load:=tr;
{$endif}
 repeat
  assign(fil,nm);
  reset(fil,1);
  io:=ioresult; _read_mem:=io;
  if io<>0 then
   if JustFilename(nm)=nm then exit
   else begin nm:=JustFilename(nm); ctrl_modif:=tr end
 until io=0;
 io:=filesize(fil);
 _read_mem:=-1;
 if (size>0) and (size<>io) then exit;
 help_mes('Reading MEMORY file');
 init_mem;
 getmem(memory,io);
 getmem(flags,io);
 fillchar(flags^,io,#0);
 blockread(fil,memory^,io,w);
 end_adress:=shift_adress+w-1;
 if io=w then _read_mem:=0 else
  begin w:=ioresult; _read_mem:=w; if w=0 then _read_mem:=$fff end;
 close(fil);
 help;
end;

function m_s(nm:string):string;
begin
 m_s:=addbackslash(justpathname(nm))+'*.'+justextension(nm)
end;

function read_memory(nm:string; size:word):bool;
var i:int; s:string; f:bool;
begin
 i:=0;
 ctrl_modif:=fl;
 repeat
  pickcmdnum:=pksnone;
  i:=getfilename(nm,anyfile,18,2,24,3,col_pick_file,s);
  if pickcmdnum=pksexit then begin read_memory:=fl; exit end;
  if i=4 then longjump(chek_memory) else
  if i in [1,2,3] then begin
    if _read_mem(nm,size)=0 then i:=0
  end else
  if i=0 then begin nm:=s; i:=_read_mem(nm,size) end;
  read_memory:=i=0;
  if i=0 then begin mem_file_name:=nm; exit end;
  case i of
   -1:s:='Invalid size of file';
    1:s:='Path not found';
    2:s:='No matching file';
    3:s:='No file';
    $fff:s:='Unexpected end of file';
  else s:='Dos critical error code '+long2str(i)
  end;
  mes('Error in memory input file '+nm+': '+s,colors.err);
  s:=nm;
  readstring('File name>',25,1,69,colors.help,colors.help,$70,f,s);
  help;
  sh_stat:=tr; show_stat;
  if f then exit;
  if s<>nm then ctrl_modif:=tr;
  if s='' then nm:=m_s(nm) else nm:=s;
 until fl
end;

function _read_f(nm:string):int;
var fil:file; io,mc,i,j,k:word; s:string; er:jumprecord;
    p_e:^ptr_entry_rec; p:ptr_entry_rec;

 procedure blk_r(var blk; s:word);
 var i:word;
 begin
  blockread(fil,blk,s,i);
  if i=s then exit;
  io:=ioresult;
  if io=0 then io:=$fff;
  close(fil);
  longjump(er);
 end;

 function rb:byte; var b:byte; begin blk_r(b,1); rb:=b end;
 function rw:word; var w:word; begin blk_r(w,2); rw:=w end;
 function rs:string; var s:string;
   begin blk_r(s,1); blk_r(s[1],ord(s[0])); rs:=s end;

 procedure read_marks;
 var p:^ptr_mark_tree; p1:ptr_mark_tree; s:string; b:byte;

  procedure read_att(var ip:ptr_att_link);
  var p,p1:ptr_att_link; b:byte;
  begin
   p:=@ip; ip:=nil;
   repeat
    b:=rb;
    if b=$ff then exit;
    new(p1);
    p1^.link:=nil;
    p^.link:=p1;
    p:=p1;
    with p^ do begin
     a_type:=t_at(b);
     blk_r(count,2)
    end
   until fl
  end;

 begin { read_marks }
  p:=@top_mark_tree; p^:=nil; mc:=0;
  repeat
   b:=rb;
   if b=$ff then exit;
   new(p1); inc(mc);
   p1^.left:=nil;
   p^:=p1;
   p:=@p1^.left;
   with p1^ do begin
    mm_type:=t_mm_type(b);
    name:=rs;
    blk_r(adress,5);
    s:=rs;
    if s<>'' then coment:=stringtoheap(s) else coment:=nil;
    read_att(att_link);
   end
  until fl
 end;

 function read_shift_tab:ptr_shift_tab;
 var m:byte; p:ptr_shift_tab;
 begin
  new(p);
  with p^ do begin
   name:=rs;
   key:=rb;
   m:=rb;
   if m and 1 <> 0 then left:=read_shift_tab
                   else left:=nil;
   if m and 2 <> 0 then right:=read_shift_tab
                   else right:=nil;
  end;
  read_shift_tab:=p;
 end;

 function read_shift_tree:ptr_shift_tree;
 var m:byte; p:ptr_shift_tree;
 begin
  new(p);
  with p^ do begin
   blk_r(cnt,2);
   m:=rb;
   if m and 1 <> 0 then shifts:=read_shift_tab
                   else shifts:=nil;
   if m and 2 <> 0 then left:=read_shift_tree
                   else left:=nil;
   if m and 4 <> 0 then right:=read_shift_tree
                   else right:=nil;
  end;
  read_shift_tree:=p;
 end;

begin { _read_f }
 io:=0; setjump(er); _read_f:=io; if io<>0 then exit;
 assign(fil,nm);
 reset(fil,1);
 io:=ioresult; _read_f:=io; if io<>0 then exit;
 _read_f:=-2;
 if rs<>ver then begin close(fil); exit end;
 i:=rw; shift_adress:=rw;
 _read_f:=-1;
 if not(read_memory(rs,i)) then begin close(fil); exit end;
 help_mes('Reading CONTROL file');
 blk_r(flags^,i);
 i:=rw;
 j:=i mod max_len_entry;
 i:=i div max_len_entry;
 top_entry:=nil;
 top_shift_tree:=nil;
 p_e:=@top_entry;
 if j<>0 then begin
  new(p);
  p^.link:=nil;
  p^.len:=j;
  p_e^:=p;
  p_e:=@p^.link;
  blk_r(p^.body,j*2)
 end;
 for k:=1 to i do begin
  new(p);
  p^.link:=nil;
  p^.len:=max_len_entry;
  p_e^:=p;
  p_e:=@p^.link;
  blk_r(p^.body,max_len_entry*2)
 end;
 read_marks;
 sort_marks(top_mark_tree,mc);
 if rb=$ff then top_shift_tree:=read_shift_tree else top_shift_tree:=nil;
 _read_f:=0;
 help;
end;

function read_f(nm:string):bool;
var i:int; s:string; f:bool;
begin
 i:=0;
 repeat
  pickcmdnum:=pksnone;
  i:=getfilename(nm,anyfile,18,2,24,3,col_pick_file,s);
  if pickcmdnum=pksexit then begin read_f:=fl; exit end;
  if i=4 then longjump(chek_memory) else
  if i=0 then begin nm:=s; i:=_read_f(nm) end;
  read_f:=i=0;
  if i=0 then begin ctrl_file_name:=nm; exit end;
  case i of
   -1:s:='No memory file';
   -2:s:='Invalid format of file';
   $fff:s:='Unexpected end of file';
    1:s:='Path not found';
    2:s:='No matching file';
    3:s:='No file';
  else s:='Dos critical error code '+long2str(i)
  end;
  mes('Error in control input file '+nm+': '+s,colors.err);
  s:=nm;
  readstring('File name>',25,1,69,colors.help,colors.help,$70,f,s);
  help;
  sh_stat:=tr; show_stat;
  if f then exit;
  if s='' then nm:=m_s(nm) else nm:=s;
 until fl
end;

procedure blk_w(var blk; s:word);
var i:word;
begin
 blockwrite(loc_fil,blk,s,i);
 if i=s then exit;
 loc_io:=ioresult;
 if loc_io=0 then loc_io:=$fff;
 close(loc_fil);
 longjump(loc_er);
end;

procedure wb(b:byte);   begin blk_w(b,1)               end;
procedure ww(w:word);   begin blk_w(w,2)               end;
procedure ws(s:string); begin blk_w(s,succ(length(s))) end;

{$F+}
procedure loc_sub(var m:mark_tree);
var p:ptr_att_link;
begin
 with m do if (mm_type<>none) or (name<>'') or (coment<>nil) or (key<>0) then
 begin
  wb(byte(mm_type));
  ws(name);
  blk_w(adress,5);
  ws(stringfromheap(coment));
  p:=att_link;
  while p<>nil do begin blk_w(p^.a_type,3); p:=p^.link end;
  wb($ff)
 end
end;
{$F-}

function _write_f(nm:string):int;
var i:word;

 procedure wr_entry;
 var i:word; p:ptr_entry_rec;
 begin
  i:=0; p:=top_entry;
  while p<>nil do begin inc(i,p^.len); p:=p^.link end;
  ww(i);
  p:=top_entry;
  while p<>nil do begin blk_w(p^.body,p^.len*2); p:=p^.link end;
 end;

 procedure wr_marks;
 begin iterator(loc_sub,tr); wb($ff) end;

 procedure write_shift_tab(p:ptr_shift_tab);
 var m:byte;
 begin
  with p^ do begin
   ws(name);
   wb(key);
   if left<>nil  then m:=1 else m:=0;
   if right<>nil then m:=m or 2;
   wb(m);
   if left<>nil  then write_shift_tab(left);
   if right<>nil then write_shift_tab(right);
  end;
 end;

 procedure write_shift_tree(p:ptr_shift_tree);
 var m:byte;
 begin
  with p^ do begin
   blk_w(cnt,2);
   if shifts=nil then m:=0 else m:=1;
   if left<>nil  then m:=m or 2;
   if right<>nil then m:=m or 4;
   wb(m);
   if shifts<>nil then write_shift_tab(shifts);
   if left<>nil  then write_shift_tree(left);
   if right<>nil then write_shift_tree(right);
  end;
 end;

begin { _write_f }
 loc_io:=0; setjump(loc_er); _write_f:=loc_io; if loc_io<>0 then exit;
 assign(loc_fil,nm);
 rewrite(loc_fil,1);
 loc_io:=ioresult; _write_f:=loc_io; if loc_io<>0 then exit;
 help_mes('Writing CONTROL file');
 ws(ver);
 i:=end_adress-shift_adress+1;
 ww(i); ww(shift_adress);
 ws(mem_file_name);
 blk_w(flags^,i);
 wr_entry;
 wr_marks;
 if top_shift_tree=nil then wb(0) else
  begin
   wb($ff);
   write_shift_tree(top_shift_tree);
  end;
 close(loc_fil);
 help;
 ctrl_modif:=fl;
 _write_f:=0;
end;

procedure write_f(nm:string);
var i:int; s:string; f:bool;
begin
 i:=0;
 repeat
  pickcmdnum:=pksnone;
  i:=getfilename(nm,anyfile,18,2,24,3,col_pick_file,s);
  if s='' then exit;
  if i=3 then i:=0;
  if i=4 then longjump(chek_memory) else
  if i=0 then begin nm:=s; i:=_write_f(nm) end;
  if i=0 then exit;
  case i of
    1:s:='Path not found';
    2:s:='No matching file';
    $fff:s:='Disk full';
  else s:='Dos critical error code '+long2str(i)
  end;
  mes('Error in output file '+nm+': '+s,colors.err);
  s:=nm;
  readstring('File name>',25,1,69,colors.help,colors.help,$70,f,s);
  help;
  sh_stat:=tr; show_stat;
  if f then exit;
  if s='' then nm:=m_s(nm) else nm:=s;
 until fl
end;

procedure info;
const chs:byte=0;
var i:int; f:bool;
begin
 chs:=choise_str('Info about:|MARKS|ENTRY|WINDOWS|MEMORY',chs,f,
                 colors.atr_type,colors.atr_mark);
 if f then exit;
 case chs of
  0:info_marks($ffff);
  1:info_entry;
  2:info_window;
  3:info_memory;
 end;
end;

var loc_text:text;

procedure wr_shift(p:ptr_shift_tree);
 procedure _wr(t:ptr_shift_tab);
 begin
  if t=nil then exit;
  _wr(t^.left);
  writeln(loc_text,pad(t^.name,10)+'EQU '+long2str(shortint(p^.val)));
  _wr(t^.right);
 end;
begin
  if p=nil then exit;
  wr_shift(p^.left);
  _wr(p^.shifts);
  wr_shift(p^.right);
end;

{$F+}
procedure loc_s2(var p:mark_tree);
var s:string;
begin
 if out_sp(p.adress) then begin
  writeln(loc_text,pad(m_name(@p),10)+'EQU '+hex(p.adress)+'H');
  if loc_io<>$ffff then begin
   while loc_mrk^[loc_io].mark<p.adress do inc(loc_io);
   s:='  ;Xref for '+hexw(loc_mrk^[loc_io].mark)+' is : ';
   while loc_mrk^[loc_io].mark=p.adress do begin
    if length(s)>74 then begin
     writeln(loc_text,s);
     s:=pad('  ;',22);
    end;
    adds(s,hexw(loc_mrk^[loc_io].pl_adr)+' ');
    inc(loc_io);
   end;
   if length(s)>22 then writeln(loc_text,s);
  end
 end
end;
{$F-}

function _gen_out(nm:string; lst:byte):word;
var i,adr,a,b,e,p:word; scr:array[0..5] of string; s:string; sz:word;
    l:longint; buf:pointer; it_sz:word;
begin
 l:=maxavail;
 if l>$FFF0 then sz:=$fff0 else sz:=l;
 getmem(buf,sz);
 assign(loc_text,nm);
 rewrite(loc_text);
 SetTextBuf(loc_text, buf^,sz);
 loc_io:=ioresult;
 if loc_io<>0 then begin _gen_out:=loc_io; freemem(buf,sz); exit end;
 if lst=2 then gen_xref;
 if lst=3 then gen_sym(loc_text) else begin
   p:=0;
   if lst=2 then loc_io:=0 else loc_io:=$ffff;
   adr:=shift_adress;
   help_mes('Writing output listing');
   it_sz:=(end_adress-adr) div 74;
   fastwrite(hexw(adr)+' '+charstr('',75),1,1,colors.atr_type);
   wr_shift(top_shift_tree);
   iterator(loc_s2,tr);
   writeln(loc_text,charstr(' ',10)+'ORG '+hex(adr)+'H');
   while not out_sp(adr) do begin
    fastwrite(hexw(adr)+' '+charstr(' ',(adr-shift_adress) div it_sz),1,1,colors.atr_type);
    b:=adr;
    gen_lst:=tr;
    write_out(adr,lst>0,fl,scr);
    gen_lst:=fl;
    e:=adr;
    i:=0;
    while scr[i]<>'' do begin
     writeln(loc_text,unpck(scr[i],255));
     inc(i)
    end;
    if lst=2 then begin
     while loc_mrk^[p].mark<b do inc(p);
     while (loc_mrk^[p].mark<e) and (loc_mrk^[p].mark>=b) do begin
      a:=loc_mrk^[p].mark;
      s:='  ;Xref for '+hexw(a)+' is : ';
      while a=loc_mrk^[p].mark do begin
       if length(s)>74 then begin
        writeln(loc_text,s);
        s:=pad('  ;',22);
       end;
       adds(s,hexw(loc_mrk^[p].pl_adr)+' ');
       inc(p);
      end;
      if length(s)>22 then writeln(loc_text,s);
     end;
    end
   end;
   if lst=2 then f_mem(loc_mrk,0,loc_st*4);
 end;
 close(loc_text);
 freemem(buf,sz);
 help;
 _gen_out:=ioresult;
end;

procedure gen_out(nm:string); label all;
var i:int; s:string; f:bool; lst:byte;
begin
{$ifdef demo}
 if was_load then begin nodo; exit end;
{$endif}
 for i:=shift_adress to end_adress do
  if fb(i) and (c_prog or c_data)=0 then begin
   if choise_str('Undefined spaces exist in memory.|Make it as DB|Cansel',1,
                 f,colors.err,colors.err_mark)=1 then exit;
   goto all
  end;
 all:
 lst:=choise_str('Output listing file format:|ASM|LST|XREF|SYM',byte(mode_lst),f,
                 colors.atr_type,colors.atr_mark);
 if f then exit;
 i:=0;
 repeat
  pickcmdnum:=pksnone;
  i:=getfilename(nm,anyfile,18,2,24,3,col_pick_file,s);
  if s='' then exit;
  if i=3 then i:=0;
  if i=4 then longjump(chek_memory) else
  if i=0 then begin
   nm:=s;
   undef_as_db:=tr;
   cvt_names := lst in [0,3];
   i:=_gen_out(nm,lst);
   cvt_names := fl;
   undef_as_db:=fl;
  end;
  if i=0 then exit;
  case i of
    1:s:='Path not found';
    2:s:='No matching file';
    $fff:s:='Disk full';
  else s:='Dos critical error code '+long2str(i)
  end;
  mes('Error in output file '+nm+': '+s,colors.err);
  s:=nm;
  readstring('File name>',25,1,69,colors.help,colors.help,$70,f,s);
  help;
  sh_stat:=tr; show_stat;
  if f then exit;
  if s='' then nm:=m_s(nm) else nm:=s;
 until fl
end;

procedure write_file;
var s:string; f:bool;
begin
 s:=ctrl_file_name;
 f:=fl;
 if (s='') or promted then readstring('File name for save>',1,1,60,
                            colors.atr_type,colors.atr_type,$70,f,s);
 sh_stat:=tr; show_stat;
 if f or (s='') then exit;
 if (stupcase(justextension(s))<>'DCT') and (choise_str(
    'File type:|OUTPUT LISTING|CONTROL',1,f,colors.atr_type,
    colors.atr_mark)=0)
 then gen_out(s) else
{$ifdef demo}
 nodo
{$else}
 write_f(s)
{$endif}
end;

function shure_save:bool;
var f:bool; i:int;
begin
 shure_save:=fl;
 while ctrl_modif do begin
  i:= choise_str('Control information modified|ABANDON CHANGES|SAVE CHANGES',
                 1,f,colors.err,colors.err_mark);
  if f then begin shure_save:=tr; exit end;
  if i=1 then write_file else exit
 end
end;

function read_file(flag:bool):bool;
var s:string; f:bool;
begin
 read_file:=tr;
 if shure_save then exit;
 if flag then s:=m_s(ctrl_file_name) else s:=ctrl_file_name;
 f:=fl;
 if (s='') or promted and flag then
     readstring('File name for load>',1,1,60,
                colors.atr_type,colors.atr_type,$70,f,s);
 sh_stat:=tr; show_stat;
 if f or (s='') then exit;
 if (stupcase(justextension(s))<>'DCT') and (choise_str(
    'File type:|MEMORY|CONTROL',1,f,colors.atr_type,colors.atr_mark)=0)
 then begin
  if get_adr(shift_adress,'Start adress of code>') then exit;
  ctrl_modif:=fl;
  if not read_memory(s,0) then halt(1);
  ctrl_file_name:=forceextension(mem_file_name,'DCT');
 end else
{$ifdef demo}
 nodo;
{$else}
 begin
  ctrl_modif:=fl;
  if not read_f(s) then halt(1);
 end;
{$endif}
 read_file:=fl;
 redraw
end;

procedure save_pick;
var fil:file; io:word; er:jumprecord; i,j:word;

 procedure blk_w(var blk; s:word);
 var i:word;
 begin
  blockwrite(fil,blk,s,i);
  if i=s then exit;
  io:=$fff;
  close(loc_fil);
  longjump(loc_er);
 end;

 procedure wb(var b);   begin blk_w(b,1)               end;
 procedure ww(var w);   begin blk_w(w,2)               end;
 procedure ws(s:string);begin blk_w(s,succ(length(s))) end;

begin
 io:=0; setjump(er); if io<>0 then exit;
 assign(fil,'DECOD.PCK');
 rewrite(fil,1);
 if ioresult<>0 then exit;
 ws(ver_pick);
 ws(ctrl_file_name);
 ww(top_scr);
 ww(cur_scr);
 wb(cur_t);
 wb(cur_st);
 wb(cur_sbt);
 wb(mode_lst);
 wb(mode_asm);
 wb(make_change);
 wb(tr_break);
 i:=head;
 j:=$ffff;
 repeat
  inc(j);
  if i=0 then i:=max_win else dec(i);
 until win_rec[i].adr_at_top=$ffff;
 ww(j);
 if j=0 then begin close(fil); exit end;
 if i=max_win then i:=0 else inc(i);
 if i>head then begin
  blk_w(win_rec[i],4*(max_win-i+1));
  dec(j,max_win-i+1);
  i:=0;
  if j=0 then begin close(fil); exit end;
 end;
 blk_w(win_rec[i],4*j);
 close(fil);
end;

function load_pick:bool;
var io,i:word; er:jumprecord; fil:file;

 procedure blk_r(var blk; s:word);
 var i:word;
 begin
  blockread(fil,blk,s,i);
  if i=s then exit;
  io:=$fff;
  close(fil);
  longjump(er);
 end;

 function rb:byte; var b:byte; begin blk_r(b,1); rb:=b end;
 function rw:word; var w:word; begin blk_r(w,2); rw:=w end;
 function rs:string; var s:string;
   begin blk_r(s,1); blk_r(s[1],ord(s[0])); rs:=s end;

begin
 load_pick:=fl;
 io:=0; setjump(er); if io<>0 then exit;
 assign(fil,'DECOD.PCK');
 reset(fil,1);
 if ioresult<>0 then exit;
 help_mes('Reading Pick file');
 if rs<>ver_pick then exit;
 if not read_f(rs) then exit;
 top_scr:=rw;
 cur_scr:=rw;
 cur_t:=t_cur_t(rb);
 cur_st:=t_at(rb);
 cur_sbt:=m_type(rb);
 mode_lst:=bool(rb);
 mode_asm:=bool(rb);
 make_change:=bool(rb);
 tr_break:=bool(rb);
 i:=rw;
 blk_r(win_rec,i*4);
 head:=i;
 close(fil);
 load_pick:=tr;
 help;
{$ifdef demo}
 was_load:=fl;
{$endif}
end;

var cur_sv1,cur_sv2:word;

procedure rest_scr;
begin
 while erasetopwindow<>nil do;
 restorecursorstate(cur_sv1,cur_sv2);
end;

{$F+}
function c_m(flag:int):int;
begin
 if flag<>0 then longjump(chek_memory);
end;

procedure post_dn;
begin
 exitproc:=sv_exitproc;
 if shure_save then;
 if exitcode=0 then begin
  help_mes('Saving pick file');
  save_pick;
 end;
 rest_scr;
 halt;
end;
{$F-}

procedure screen_handl;
var s:string; fo:array[0..4] of string; i:word; choise:byte;
begin
 redraw;
 choise:=0;
 repeat
  if make_change then s:=atr_cur else
  if fb(cur_scr) and (c_prog or c_data)=0 then s:='' else begin
   i:=cur_scr;
   write_out(i,mode_lst,mode_asm,fo);
   s:=unpck_a(fo[0]);
   if mode_lst then s:=#27#10+s+#67#14 else s:=#1#10+s+#46#35;
  end;
  show_stat;
  help;
  case one_str_cs(s,choise,abs_cur_pos+2,colors.sel_mark) of
   $4800:step_up;
   $5000:step_dn;
   $4900:for i:=0 to 20 do step_up;
   $5100:for i:=0 to 20 do step_dn;
   $2d00:exit;
   $011b:if rs_win then;
   $0f09:set_mode;
   $4200:begin make_change:=not make_change; redraw end;
   $5200:if make_change then make_cur(choise) else make_fild(choise);
   $1c0a:if make_change then begin
           if (fb(cur_scr) and (c_prog or c_data)) = 0 then setf(cur_scr,c_entry);
           change_fl
         end
         else step_prog(choise,$1c0a);
   $1c0d:if make_change then change_fl else step_prog(choise,$1c0d);
   $3e00:get_mark(choise);
   $1f00:begin if g_a_f(i,choise) then i:=cur_scr;
               _make_mark(i, get_sh);
         end;
   $2600:begin if g_a_f(i,choise) then i:=cur_scr;
               _make_mark(i, get_lp);
         end;
   $5300:if choise=0 then del_mark(cur_scr) else
         if choise*3>length(up_ns) then del_com(cur_scr);
   $4000:aut_tr;
   $8400:to_up;
   $7600:to_dn;
   $3f00:att_fil(choise);
   $3c00:write_file;
   $3d00:if read_file(tr) then ;
   $4100:info;
   $6400:info_prim(choise);
   $5A00:promted:=not promted;
   $4300:w_calc;

  end
 until fl
end;

begin
 writeln('Z80 dissasembler V1.06.   Copyright (C) 1990,92 by  XVR - Product.');
 writeln;
 getcursorstate(cur_sv1,cur_sv2);
 f_t_buf[0]:=^Z;
 scr_loc_stat:=kbdflags and $10;
 ctrl_file_name:='*.dct';
 shift_adress:=0;
 con_err:=0;
 heaperror:=@c_m;
 setjump(chek_memory);
 if con_err>0 then
  begin rest_scr; writeln('Insufficient memory'); halt(1) end;
 con_err:=1;
 if not makewindow(win,1,1,80,25,fl,tr,fl,colors.undef,0,0,'') or
    not displaywindow(win)  then longjump(chek_memory);
 if addpickcommand(pksuser0,1,$5200,0) then ;
 if addpickcommand(pksuser1,1,$5300,0) then ;
 if addpickcommand(pksuser2,1,$3c00,0) then ;
 if addmemocommand(emuser0,1,$3c00,0) then ;
 setframechars('','','','','','');
 show_stat;
{$ifdef demo}
 framewindow(24,7,55,18,$7f,0,'');
{$else}
 framewindow(24,7,55,17,$7f,0,'');
{$endif}
 fastwrite(center('ZDIS     V1.08',30),10,25,$70);
 fastwrite(center('Z80 Dissasembler',30),11,25,$70);
 fastfill(30,' ',12,25,$70);
 fastfill(30,' ',9,25,$70);
 fastfill(30,' ',8,25,$70);
 fastfill(30,' ',15,25,$70);
 fastfill(30,' ',16,25,$70);
 fastwrite(center('Copyright (c) 1992,93',30),13,25,$70);
 fastwrite(center('by XVR - Product',30),14,25,$70);
{$ifdef demo}
 fastwrite(center('DEMO  version',30),17,25,$7c);
{$endif}
 picksrch:=stringpicksrch;
 editkeyptr:=@readkeyw;
 statusrow:=1;
 statusattr:=colors.atr_type;
 memostatusptr:=@mem_st;
 memokeyptr:=@get_mk;
 c_off;
 mark(bot_mem);
 init_mem;
 if ParamCount>0 then begin
  ctrl_file_name:=DefaultExtension(ParamStr(1),'dct');
  if read_file(fl) then begin rest_scr; halt(1) end;
 end else
 if not load_pick then begin
  ctrl_modif:=fl;
{$ifdef demo}
      rest_scr; halt(1);
{$endif}
  if read_file(tr) then begin rest_scr; halt(1) end;
 end;
 sv_exitproc:=exitproc;
 exitproc:=@post_dn;
 con_err:=4;
 setjump(chek_memory);
 inc(con_err);
 setjump(chek_fix);
 inc(con_err);
 setjump(bounds);
 case con_err of
  0:begin mes('Out of work space',colors.err);
          cur_scr:=shift_adress;
          top_scr:=cur_scr
    end;
  1:mes('Fix-conflict',colors.err);
  2:mes('Insufficient memory',colors.err);
 end;
 con_err:=0;
 help;
 screen_handl;
end.

