unit xconst;
interface

type    int =integer;
        bool=boolean;

const   fl  =false;
        tr  =true;
		      { Value for some chars }
   C_esc = ^[; C_tab = ^I; C_bs = ^H; C_enter = ^M; Cc_enter = ^J;

   C_F1  = #59;  C_F2  = #60;  C_F3  = #61;  C_F4  = #62;  C_F5  = #63;
   C_F6  = #64;  C_F7  = #65;  C_F8  = #66;  C_F9  = #67;  C_F10 = #68;

   Cc_F1 = #94 ; Cc_F2 = #95 ; Cc_F3 = #96 ; Cc_F4 = #97 ; Cc_F5 = #98 ;
   Cc_F6 = #99 ; Cc_F7 = #100; Cc_F8 = #101; Cc_F9 = #102; Cc_F10= #103;

   Ca_F1 = #104; Ca_F2 = #105; Ca_F3 = #106; Ca_F4 = #107; Ca_F5 = #108;
   Ca_F6 = #109; Ca_F7 = #110; Ca_F8 = #111; Ca_F9 = #112; Ca_F10= #113;

   Cs_F1 = #84;  Cs_F2 = #85;  Cs_F3 = #86;  Cs_F4 = #87;  Cs_F5 = #88;
   Cs_F6 = #89;  Cs_F7 = #90;  Cs_F8 = #91;  Cs_F9 = #92;  Cs_F10= #93;

   C_left= #75;  C_right= #77; C_home = #71; C_end = #79;  C_PgUp= #73;
   C_PgDn= #81;  C_ins  = #82; C_del  = #83; C_up  = #72;  C_dn  = #80;

   Cc_left= #115; Cc_right= #116; Cc_home = #119; Cc_end = #117;
   Cc_PgUp= #132; Cc_PgDn = #118; Cs_tab  = #15 ; Cc_PrtSc=#114;

   Ca_A = #30; Ca_B = #48; Ca_C = #46; Ca_D = #32; Ca_E = #18; Ca_F = #33;
   Ca_G = #34; Ca_H = #35; Ca_I = #23; Ca_J = #36; Ca_K = #37; Ca_L = #38;
   Ca_M = #50; Ca_N = #49; Ca_O = #24; Ca_P = #25; Ca_Q = #16; Ca_R = #19;
   Ca_S = #31; Ca_T = #20; Ca_U = #22; Ca_V = #47; Ca_W = #17; Ca_X = #45;
   Ca_Y = #21; Ca_Z = #44; Ca_0 = #129;Ca_1 = #120;Ca_2 = #121;Ca_3 = #122;
   Ca_4 = #123;Ca_5 = #124;Ca_6 = #125;Ca_7 = #126;Ca_8 = #127;Ca_9 = #128;
   Ca_sub=#130;Ca_eq= #131;

                      { Scan code for same chars }
  S_F1  =$3B00; S_F2  =$3C00; S_F3  =$3D00; S_F4  =$3E00; S_F5  =$3F00;
  S_F6  =$4000; S_F7  =$4100; S_F8  =$4200; S_F9  =$4300; S_F10 =$4400;

  Ss_F1 =$5400; Ss_F2 =$5500; Ss_F3 =$5600; Ss_F4 =$5700; Ss_F5 =$5800;
  Ss_F6 =$5900; Ss_F7 =$5A00; Ss_F8 =$5B00; Ss_F9 =$5C00; Ss_F10=$5D00;

  Sc_F1 =$5E00; Sc_F2 =$5F00; Sc_F3 =$6000; Sc_F4 =$6100; Sc_F5 =$6200;
  Sc_F6 =$6300; Sc_F7 =$6400; Sc_F8 =$6500; Sc_F9 =$6600; Sc_F10=$6700;

  Sa_F1 =$6800; Sa_F2 =$6900; Sa_F3 =$6A00; Sa_F4 =$6B00; Sa_F5 =$6C00;
  Sa_F6 =$6D00; Sa_F7 =$6E00; Sa_F8 =$6F00; Sa_F9 =$7000; Sa_F10=$7100;

  Sa_A = $1E00; Sa_B = $3000; Sa_C = $2E00; Sa_D = $2000; Sa_E = $1200;
  Sa_F = $2100; Sa_G = $2200; Sa_H = $2300; Sa_I = $1700; Sa_J = $2400;
  Sa_K = $2500; Sa_L = $2600; Sa_M = $3200; Sa_N = $3100; Sa_O = $1800;
  Sa_P = $1900; Sa_Q = $1000; Sa_R = $1300; Sa_S = $1F00; Sa_T = $1400;
  Sa_U = $1600; Sa_V = $2F00; Sa_W = $1100; Sa_X = $2D00; Sa_Y = $1500;
  Sa_Z = $2C00; Sa_0 = $8100; Sa_1 = $7800; Sa_2 = $7900; Sa_3 = $7A00;
  Sa_4 = $7B00; Sa_5 = $7C00; Sa_6 = $7D00; Sa_7 = $7E00; Sa_8 = $7F00;
  Sa_9 = $8000; Sa_sub=$8200; Sa_eq= $8300;

  Sc_A = $1E01; Sc_B = $3002; Sc_C = $2E03; Sc_D = $2004; Sc_E = $1205;
  Sc_F = $2106; Sc_G = $2207; Sc_H = $2308; Sc_I = $1709; Sc_J = $240A;
  Sc_K = $250B; Sc_L = $260C; Sc_M = $320D; Sc_N = $310E; Sc_O = $180F;
  Sc_P = $1910; Sc_Q = $1011; Sc_R = $1312; Sc_S = $1F13; Sc_T = $1414;
  Sc_U = $1615; Sc_V = $2F16; Sc_W = $1117; Sc_X = $2D18; Sc_Y = $1519;
  Sc_Z = $2C1A;
  Sc_OpBr = $1A1B; { ^[ } Sc_ClBr = $1B1D; { ^] } Sc_BkSl = $2B1C; { ^\ }
  Sc_Undl = $0C1F; { ^_ } Sc_Ptr  = $071E; { ^^ }

  S_A  = $1E41; S_B  = $3042; S_C  = $2E43; S_D  = $2044; S_E  = $1245;
  S_F  = $2146; S_G  = $2247; S_H  = $2348; S_I  = $1749; S_J  = $244A;
  S_K  = $254B; S_L  = $264C; S_M  = $324D; S_N  = $314E; S_O  = $184F;
  S_P  = $1950; S_Q  = $1051; S_R  = $1352; S_S  = $1F53; S_T  = $1454;
  S_U  = $1655; S_V  = $2F56; S_W  = $1157; S_X  = $2D58; S_Y  = $1559;
  S_Z  = $2C5A; S_sa = $1E61; S_sb = $3062; S_sc = $2E63; S_sd = $2064;
  S_se = $1265; S_sf = $2166; S_sg = $2267; S_sh = $2368; S_si = $1769;
  S_sj = $246A; S_sk = $256B; S_sl = $266C; S_sm = $326D; S_sn = $316E;
  S_so = $186F; S_sp = $1970; S_sq = $1071; S_sr = $1372; S_ss = $1F73;
  S_st = $1474; S_su = $1675; S_sv = $2F76; S_sw = $1177; S_sx = $2D78;
  S_sy = $1579; S_sz = $2C7A;

  S_0  = $8130; S_1  = $7831; S_2  = $7932; S_3  = $7A33; S_4  = $7B34;
  S_5  = $7C35; S_6  = $7D36; S_7  = $7E37; S_8  = $7F38; S_9  = $8039;
  S_sps= $8120; S_1sg= $7821; S_2sg= $7922; S_3sg= $7A23; S_4sg= $7B24;
  S_5sg= $7C25; S_6sg= $7D26; S_7sg= $7E27; S_8sg= $7F28; S_9sg= $8029;

  S_esc =$011b; S_tab =$0f09; S_bs = $0e08; S_enter=$1c0d; Sc_enter =$1c0a;
  S_left=$4B00; S_right=$4d00;S_home=$4700; S_end = $4f00; S_PgUp= $4900;
  S_PgDn=$5100; S_ins = $5200;S_del =$5300; S_up  = $4800; S_dn  = $5000;
  Sc_left=$7300; Sc_right=$7400; Sc_home =$7700; Sc_end =$7500;
  Sc_PgUp=$8400; Sc_PgDn =$7600; Ss_tab  =$0F00; Sc_PrtSc=$7200;

  S_aus = $092A; S_dp  = $273A;  { * / : }
  S_add = $0D2B; S_pac = $273B;  { + / ; }
  S_com = $332C; S_les = $333C;  { , / < }
  S_sub = $822D; S_eq  = $833D;  { - / = }
  S_pnt = $342E; S_grt = $343E;  { . / > }
  S_slh = $352F; S_qsg = $353F;  { /   ? }
  S_at  = $0340; S_bap = $2960;  { @ / ` }
  S_OpBr= $1A5B; S_OpF = $1A7B; (* [ / { *)
  S_BkSl= $2B5C; S_vst = $2B7C;  { \ / | }
  S_ClBr= $1B5D; S_ClF = $1B7D; (* ] / } *)
  S_Ptr = $075E; S_til = $297E;  { ^ / ~ }
  S_Undl= $0C5F;                 { _ }

  procedure push(b:word);      inline($90); { nop }

  procedure push_L(b:longint); inline($90); { nop }

  procedure pop_B(var b:byte);
   inline($5F/         { pop di }
          $07/         { pop es }
          $58/         { pop ax }
          $26/$88/$05);{ mov es:[di],al }

  procedure pop_W(var w:word);
   inline($5F/         { pop di }
          $07/         { pop es }
          $26/$8F/$05);{ pop es:[di] }

  procedure pop_L(var w:longint);
   inline($5F/         { pop di }
          $07/         { pop es }
          $58/         { pop ax }
          $AB/         { stosw }
          $26/$8F/$05);{ pop es:[di] }

  procedure push_A(var a; len:word);
   inline($8C/$DA/     { mov dx,ds }
          $58/         { pop ax }
          $5E/         { pop si }
          $1F/         { pop ds }
          $16/         { push ss }
          $07/         { pop es }
          $2B/$E0/     { sub sp,ax }
          $8B/$FC/     { mov di,sp }
          $FC/         { cld }
          $8B/$C8/     { mov cx,ax }
          $D1/$E9/     { shr cx,1 }
          $F3/$A5/     { rep movsw }
          $D1/$D1/     { rcl cx,1 }
          $F3/$A4/     { rep movsb }
          $50/         { push ax }
          $8E/$DA);    { mov ds,dx }

  procedure pop_A(var a);
   inline($5F/         { pop di }
          $07/         { pop es }
          $58/         { pop ax }
          $8C/$DA/     { mov dx,ds }
          $16/         { push ss }
          $1F/         { pop ds }
          $8B/$F4/     { mov si,sp }
          $FC/         { cld }
          $8B/$C8/     { mov cx,ax }
          $D1/$E9/     { shr cx,1 }
          $F3/$A5/     { rep movsw }
          $D1/$D1/     { rcl cx,1 }
          $F3/$A4/     { rep movsb }
          $03/$E0/     { add sp,ax }
          $8E/$DA);    { mov ds,dx }

  function Caller(level:word):pointer;
   inline($59/            {     pop cx }
          $8B/$DD/        {     mov bx,bp }
          $E3/$05/        {     jcxz sh }
          $36/$8B/$1F/    { lp: mov bx,ss:[bx] }
          $E2/$FB/        {     loop lp }
          $36/$8B/$47/$02/{ sh: mov ax,ss:[bx+2] }
          $36/$8B/$57/$04);{    mov dx,ss:[bx+4] }

  function Caller_N(level:word; Flevel:integer):pointer;
   inline($8C/$CA/        {     mov dx,cs }
          $8B/$DD/        {     mov bx,bp }
          $59/            {     pop cx }
          $33/$C0/        {     xor ax,ax }
          $0A/$ED/        {     or  ch,ch }
          $75/$0D/        {     jne mcs }
          $8B/$C1/        {     mov ax,cx }
          $E3/$05/        {     jcxz sh1 }
          $36/$8B/$1F/    {lp1: mov bx,ss:[bx] }
          $E2/$FB/        {     loop lp1 }
          $36/$8B/$57/$04/{sh1: mov dx,ss:[bx+4] }
          $59/            {mcs: pop cx }
          $2B/$C8/        {     sub cx,ax }
          $74/$05/        {     je  sh2   }
          $36/$8B/$1F/    {lp2: mov bx,ss:[bx] }
          $E2/$FB/        {     loop lp2 }
          $36/$8B/$47/$02);{sh2: mov ax,ss:[bx+2] }

  function AddP(P:Pointer; Delta:longint):pointer;
   inline($58/      {    pop ax }
          $5B/      {    pop bx }
          $5A/      {    pop dx }
          $59/      {    pop cx }
          $03/$C2/  {    add ax,dx }
          $8B/$D0/  {    mov dx,ax }
          $73/$01/  {    jnc sh }
          $43/      {    inc bx }
          $25/$0F/0/{sh: and ax,0fh }
          $D1/$DB/  {    rcr bx,1 }
          $D1/$DA/  {    rcr dx,1 }
          $D1/$DB/  {    rcr bx,1 }
          $D1/$DA/  {    rcr dx,1 }
          $D1/$DB/  {    rcr bx,1 }
          $D1/$DA/  {    rcr dx,1 }
          $D1/$DB/  {    rcr bx,1 }
          $D1/$DA/  {    rcr dx,1 }
          $03/$D1); {    add dx,cx }

  function SubP(P1,P2:Pointer):Longint;
   inline($59/     { pop cx }    
          $5A/     { pop dx }    
          $5B/     { pop bx }    
          $58/     { pop ax }    
          $2B/$C2/ { sub ax,dx } 
          $1B/$D2/ { sbb dx,dx } 
          $2B/$D9/ { sub bx,cx } 
          $1B/$C9/ { sbb cx,cx } 
          $D1/$E0/ { shl ax,1 }  
          $D1/$D2/ { rcl dx,1 }  
          $D1/$E0/ { shl ax,1 }  
          $D1/$D2/ { rcl dx,1 }  
          $D1/$E0/ { shl ax,1 }  
          $D1/$D2/ { rcl dx,1 }  
          $D1/$E0/ { shl ax,1 }  
          $D1/$D2/ { rcl dx,1 }  
          $03/$C3/ { add ax,bx } 
          $13/$D1);{ adc dx,cx } 

implementation

end.
